%% Calculate humeral elevation amplitude for each trial

%% Load Data
clear all, close all
load('CTRL_aligned_data.mat','ca');
gab=load('GUST_aligned_data.mat','ga');
gab=gab.ga;
gaw = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Asymmetry/Wing Perturbations/Asymmetry_Analysis.mat','ga');
gaw=gaw.ga;
% load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Asymmetry/Body Perturbations/Asymmetry_Analysis_BodyPerturbations.mat')
% 

%% Humeral Elevation Amplitude
k=2;
c = ca(:,:,k);
gb = gab(:,:,k);
gw = gaw(:,:,k);

us1c = max(c(175:225,:)) - min(c(125:175,:));
us1g = max(gb(175:225,:)) - min(gb(125:175,:));

csvwrite('us1c.csv',us1c);csvwrite('us1g.csv',us1g);

figure, boxplot(us1c),hold on,boxplot(us1g)
[h p ci stats] = ttest2(us1g,us1c,'Alpha',0.01)
%%
amp=NaN(120,1);

%pyc1, L
a=NaN(5,1);
d=c;
s=1;
f=1;
e=300;
pks=findpeaks(d(:,s)),  a(f)=pks(1); a(f+2)=pks(2);
pks=findpeaks(-d(:,s)), a(f+1)=pks(1); a(f+3)=pks(2);
a(f+4)=d(300,s);
for i=1:4, amp(f*i,1)=abs(a(i+1)+a(i)); end

%pyc1, R
clear a
d=c;
s=2;
f=1;
pks=findpeaks(d(:,s)), a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=pks(3);
pks=findpeaks(-d(:,s)),a(f+1)=pks(1); a(f+3)=pks(2);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)); end
amp(5:8)=temp;

%pyc3, L
clear a
d=c;
s=3;
f=1;
pks=findpeaks(d(:,s)),
pks(2:3)=pks(3:4)
a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=pks(3);
pks=findpeaks(-d(:,s)), a(f+1)=pks(1); a(f+3)=pks(3);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)); end
amp(9:12,1)=temp;

%pyc3, R
clear a
d=c;
s=4;
f=1;
pks=findpeaks(d(:,s)), a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=pks(3);
pks=findpeaks(-d(:,s)),a(f+1)=pks(1); a(f+3)=pks(2);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)); end
amp(13:16)=temp;

%rbc5, L
clear a
d=c;
s=5;
f=1;
e=301;
pks=findpeaks(d(100:end,s)), a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=d(e,s);
pks=findpeaks(-d(100:end,s)),a(f+1)=pks(1); a(f+3)=pks(2);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(17:20)=temp;

%rbc5, R
clear a
d=c;
s=6;
f=1;
e=301;
pks=findpeaks(d(100:end,s)), a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=d(e,s);
pks=findpeaks(-d(100:end,s)),a(f+1)=pks(1); a(f+3)=pks(2);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(21:24)=temp;

%rbc6, L
clear a
d=c;
s=7;
f=1;
e=301;
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)),a(f+1)=pks(1); a(f+3)=pks(2);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(25:28)=temp;

%rbc6, R
clear a
d=c;
s=8;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(100:end,s)), a(f)=pks(1); a(f+2)=pks(2);
a(f+4)=pks(3);
pks=findpeaks(-d(100:end,s)),a(f+1)=pks(1); a(f+3)=pks(2);
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(29:32)=temp;



%% Wng Pert 
%     Which wing is perturbed?
%         RBg007: L
%         PYg001: L
%         PYg002: L
%         PYg016: R
%         GGg008: R
%         GGg009: R
%         RBg017: L
% % rbg7, P (L)
% clear a
% d=gw;
% s=1;
% f=1;
% e=301;
% plot(d(:,s))
% pks=findpeaks(d(:,s)), a(f+2)=pks(1); a(f+4)=pks(2);
% pks=findpeaks(-d(:,s)), a(f+1)=pks(1); a(f+3)=pks(2);
% a(a==0)=NaN
% for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
% amp(33:36)=temp;

%pyg1, P (L)
clear a
d=gw;
s=3;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(33:36)=temp;

%pyg1, U (R)
clear a
d=gw;
s=4;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(37:40)=temp;

%pyg2, P (L)
clear a
d=gw;
s=5;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(4); a(f+4)=pks(5);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(4);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(41:44)=temp;

%pyg2, U (R)
clear a
d=gw;
s=6;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(45:48)=temp;

%pyg16, P (R)
clear a
d=gw;
s=8;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(2); a(f+2)=pks(3); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(49:52)=temp;

%pyg16, U (L)
clear a temp
d=gw;
s=7;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(4); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(3); a(f+3)=pks(4);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(53:56)=temp;

%ggg008, P (R)
clear a temp
d=gw;
s=10;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(57:60)=temp;

%ggg008, U (L)
clear a temp
d=gw;
s=9;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(4); a(f+4)=pks(5);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(4);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(61:64)=temp;

%ggg009, P (R)
clear a temp
d=gw;
s=12;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(3); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(65:68)=temp;

%ggg009, U (L)
clear a temp
d=gw;
s=11;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(2); a(f+2)=pks(3); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(69:72)=temp;

%% Body Pert
%pyg6, L
clear a temp
d=gb;
s=1;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(3); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(4);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(73:76)=temp;

%pyg6, R
clear a temp
d=gb;
s=2;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(3); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(77:80)=temp;

%pyg17, L
clear a temp
d=gb;
s=3;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(81:84)=temp;

%pyg17, R
clear a temp
d=gb;
s=4;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(85:88)=temp;

%rbg11, L
clear a temp
d=gb;
s=5;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(95:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=pks(3);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(2);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(89:92)=temp;

%rbg11, R
clear a temp
d=gb;
s=6;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(80:end,s)), a(f)=pks(1); a(f+2)=pks(3); a(f+4)=pks(4);
pks=findpeaks(-d(95:end,s)), a(f+1)=abs(pks(1)); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(93:96)=temp;

%ggg2, L
clear a temp
d=gb;
s=9;
f=1;
e=251;
plot(d(:,s))
pks=findpeaks(d(80:end,s)), a(f)=pks(1); a(f+2)=pks(3); a(f+4)=NaN;
pks=findpeaks(-d(95:end,s)), a(f+1)=abs(pks(2)); a(f+3)=abs(d(e,s));
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(97:100)=temp;

%ggg2, R
clear a temp
d=gb;
s=10;
f=1;
e=251;
plot(d(:,s))
pks=findpeaks(d(80:end,s)), a(f)=pks(1); a(f+2)=pks(2); a(f+4)=NaN;
pks=findpeaks(-d(95:end,s)), a(f+1)=abs(pks(1)); a(f+3)=abs(d(e,s));
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(101:104)=temp;

%ggg21, L
clear a temp
d=gb;
s=11;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(80:end,s)), a(f)=pks(1); a(f+2)=pks(4); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(105:108)=temp;

%ggg21, R
clear a temp
d=gb;
s=12;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(80:end,s)), a(f)=pks(1); a(f+2)=pks(4); a(f+4)=pks(5);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(109:112)=temp;

%bgg4, L
clear a temp
d=gb;
s=15;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(90:end,s)), a(f)=NaN; a(f+2)=pks(4); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(2); a(f+3)=pks(5);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(113:116)=temp;

%bgg4, R
clear a temp
d=gb;
s=16;
f=1;
e=301;
plot(d(:,s))
pks=findpeaks(d(80:end,s)), a(f)=NaN; a(f+2)=pks(2); a(f+4)=d(e,s);
pks=findpeaks(-d(95:end,s)), a(f+1)=pks(1); a(f+3)=pks(3);
a(a==0)=NaN
for i=1:4, temp(i,1)=abs(a(i+1)+a(i)), end
amp(117:120)=temp;

csvwrite('hum_amp.csv',amp)