
clear
close all

%% Load Data
vars = {'ga','ga_asym'};
% Control Data
load('CTRL_aligned_data.mat','ca');
load('CTRL_aligned_asym.mat','cay');
rng=[95:304];
ca=ca(rng,:,:); cay=cay(rng,:,:);

% Body-Perturbed Data
load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Asymmetry/Body Perturbations/Asymmetry_Analysis_BodyPerturbations.mat',vars{:});
gb = ga(rng,:,:); gbay = ga_asym(rng,:,:); clear ga ga_asym
del=[7,8,13,14]; gb(:,del,:)=[]; del=[4,7]; gbay(:,del,:)=[];
% Wing-Perturbed Data
load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Asymmetry/Wing Perturbations/Asymmetry_Analysis.mat',vars{:});
gw = ga(rng,3:12,:); gway = ga_asym(rng,2:6,:); clear ga ga_asym vars

%%
% Aligned kinematics for left and right wings
% ga(:,:,1) = wing extension
% ga(:,:,2) = elevation
% ga(:,:,3) = protraction
% ga(:,:,4) = elbow extension
% ga(:,:,5) = wrist extension
% ga(:,:,6) = AoA

% Aligned asymmetry measurements
% ga_asym(:,:,1) = wing extension
% ga_asym(:,:,2) = elevation
% ga_asym(:,:,3) = protraction
% ga_asym(:,:,4) = elbow extension
% ga_asym(:,:,5) = wrist extension
% ga_asym(:,:,6) = AoA

% New dataframe will have 18 columns: one for each wing's kinematics (6x2) and one for each measurement's asymmetry (6x1)

% Number of averages per two analyzed wingbeats
int = [1:20];

d=ca; % Control Kinematics
for i=1:6
    for j=1:size(d,2)
        for k=int
            dm(k,j,i) = nanmean(d(k*10-9:k*10,j,i));
        end
    end
end
meansca = reshape(dm,[],6);
clear d dm i j k

d=cay; % Control Asymmetry
for i=1:6
    for j=1:size(d,2)
        for k=int
            dm(k,j,i) = nanmean(d(k*10-9:k*10,j,i));
        end
    end
end
meanscay = reshape(dm,[],6);
clear d dm i j k

d=gw; % Wing-Perturbed Kinematics
for i=1:6
    for j=1:size(d,2)
        for k=int
            dm(k,j,i) = nanmean(d(k*10-9:k*10,j,i));
        end
    end
end
meansgw = reshape(dm,[],6);
clear d dm i j k

d=gway; % Wing-Perturbed Asymmetry
for i=1:6
    for j=1:size(d,2)
        for k=int
            dm(k,j,i) = nanmean(d(k*10-9:k*10,j,i));
        end
    end
end
meansgway = reshape(dm,[],6);

clear d dm i j k

d=gb; % Body-Perturbed Kinematics
for i=1:6
    for j=1:size(d,2)
        for k=int
            dm(k,j,i) = nanmean(d(k*10-9:k*10,j,i));
        end
    end
end 
meansgb = reshape(dm,[],6);
clear d dm i j k

d=gbay; % Body-Perturbed Asymmetry
for i=1:6
    for j=1:size(d,2)
        for k=int
            dm(k,j,i) = nanmean(d(k*10-9:k*10,j,i));
        end
    end
end
meansgbay = reshape(dm,[],6);
clear d dm i j k



kins  = vertcat(meansca, meansgw, meansgb);
asyms = vertcat(meanscay, meansgway, meansgbay);

%%
csvwrite('kinematics_means_2.csv',kins)
csvwrite('asyms_means_2.csv',asyms)
% 
% figure(6),for i=1:8,scatter(1:10:200,dm(:,i,2),[],'r'),hold on,end
% figure(7),for i=1:8,scatter(1:10:200,dm(:,i,1),[],'r'),hold on,end