%% Asymmetry Analysis for Body Perturbations

%% Create Grand Mean Control Data (Reference for Perturbation Trials)
clear all
close all

% Variables to load for each trial
% vars = {'nk','norm_domain','Std','asym','roll','rollV','pitch','pitchV','yaw','yawV'};
vars = {'Kinematics','nk','norm_domain','asym','r','rv','p','pv','y','yv','gust'};

% Load Variables for each control trial
PYc001 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/PYc001.mat',vars{:});
PYc003 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/PYc003.mat',vars{:});
RBc005 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/RBc005.mat',vars{:});
RBc006 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/RBc006.mat',vars{:});

% nd = PYc001.norm_domain(:,1);

% Matrices for each kinematic variable (nk = norm_kinematics, i.e. kins normalized to wingbeats)
        % nk(:,1) = extNorm_L;
        % nk(:,2) = extNorm_R;
        % nk(:,3) = Roll;
        % nk(:,4) = elev_R;
        % nk(:,5) = prot_L;
        % nk(:,6) = prot_R;
        % nk(:,7) = elbL;
        % nk(:,8) = elbR;
        % nk(:,9) = dang3_radL;
        % nk(:,10) = dang3_radR;
        % nk(:,11) = r;
        % nk(:,12) = p;
        % nk(:,13) = y;
        % nk(:,14) = rv;
        % nk(:,15) = pv;
        % nk(:,16) = yv;
        % nk(:,17) = gust;
        % nk(:,18) = AoAL;
        % nk(:,19) = AoAr;
        % nk(:,20:22) = shdmid position in global space (axes defined by window)
 
pshft = 50;        
    % Humeral Elevation & Depression
    l=3; r=4;
    elev = NaN(length(PYc003.nk)+50,8);
    elev(1:length(PYc001.nk),1) = PYc001.nk(:,l); % elev_L
    elev(1:length(PYc001.nk),2) = PYc001.nk(:,r); % elev_R
    elev(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % elev_L %PYc003 needs shifting .5 wingbeat to align with others
    elev(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % elev_R %PYc003 needs shifting .5 wingbeat to align with others
    elev(1:length(RBc005.nk),5) = RBc005.nk(:,l); % elev_L
    elev(1:length(RBc005.nk),6) = RBc005.nk(:,r); % elev_R
    elev(1:length(RBc006.nk),7) = RBc006.nk(:,l); % elev_L
    elev(1:length(RBc006.nk),8) = RBc006.nk(:,r); % elev_R
    elev(elev==0)=NaN;
    elev_refmean = nanmean(elev,2);
    elev_refsd   = nanstd(elev,0,2);
    
    % Humeral Protraction & Retraction
    l=5; r=6;
    prot = NaN(length(PYc003.nk)+50,8);
    prot(1:length(PYc001.nk),1) = PYc001.nk(:,l); % prot_L
    prot(1:length(PYc001.nk),2) = (PYc001.nk(:,r)); % prot_R
    prot(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % prot_L %PYc003 needs shifting .5 wingbeat to align with others
    prot(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % prot_R %PYc003 needs shifting .5 wingbeat to align with others
    prot(1:length(RBc005.nk),5) = RBc005.nk(:,l); % prot_L
    prot(1:length(RBc005.nk),6) = (RBc005.nk(:,r)); % prot_R
    prot(1:length(RBc006.nk),7) = RBc006.nk(:,l); % prot_L
    prot(1:length(RBc006.nk),8) = (RBc006.nk(:,r)); % prot_R
    prot_refmean = nanmean(prot,2);
    prot_refsd   = nanstd(prot,0,2);
    
    % Elbow Flexion & Extension
    l=7; r=8;
    elb = NaN(length(PYc003.nk)+50,8);
    elb(1:length(PYc001.nk),1) = PYc001.nk(:,l); % elb_L
    elb(1:length(PYc001.nk),2) = PYc001.nk(:,r); % elb_R
    elb(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % elb_L %PYc003 needs shifting .5 wingbeat to align with others
    elb(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % elb_R %PYc003 needs shifting .5 wingbeat to align with others
    elb(1:length(RBc005.nk),5) = RBc005.nk(:,l); % elb_L
    elb(1:length(RBc005.nk),6) = RBc005.nk(:,r); % elb_R
    elb(1:length(RBc006.nk),7) = RBc006.nk(:,l); % elb_L
    elb(1:length(RBc006.nk),8) = RBc006.nk(:,r); % elb_R
    elb_refmean = nanmean(elb,2);
    elb_refsd   = nanstd(elb,0,2);    
   
    % Wing Extension & Folding
    l=1; r=2;
    ext = NaN(length(PYc003.nk)+50,8);
    ext(1:length(PYc001.nk),1) = PYc001.nk(:,l); % ext_L
    ext(1:length(PYc001.nk),2) = PYc001.nk(:,r); % ext_R
    ext(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % ext_L %PYc003 needs shifting .5 wingbeat to align with others
    ext(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % ext_R %PYc003 needs shifting .5 wingbeat to align with others
    ext(1:length(RBc005.nk),5) = RBc005.nk(:,l); % ext_L
    ext(1:length(RBc005.nk),6) = RBc005.nk(:,r); % ext_R
    ext(1:length(RBc006.nk),7) = RBc006.nk(:,l); % ext_L
    ext(1:length(RBc006.nk),8) = RBc006.nk(:,r); % ext_R
    ext_refmean = nanmean(ext,2);
    ext_refsd   = nanstd(ext,0,2);    
   
    % Handwing Spreading
    l=9; r=10;
    hnd = NaN(length(PYc003.nk)+50,8);
    hnd(1:length(PYc001.nk),1) = PYc001.nk(:,l); % hnd_L
    hnd(1:length(PYc001.nk),2) = PYc001.nk(:,r); % hnd_R
    hnd(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % hnd_L %PYc003 needs shifting .5 wingbeat to align with others
    hnd(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % hnd_R %PYc003 needs shifting .5 wingbeat to align with others
    hnd(1:length(RBc005.nk),5) = RBc005.nk(:,l); % hnd_L
    hnd(1:length(RBc005.nk),6) = RBc005.nk(:,r); % hnd_R
    hnd(1:length(RBc006.nk),7) = RBc006.nk(:,l); % hnd_L
    hnd(1:length(RBc006.nk),8) = RBc006.nk(:,r); % hnd_R
    hnd_refmean = nanmean(hnd,2);
    hnd_refsd   = nanstd(hnd,0,2);
    
    % Angle of Attack
    l=18; r=19;
    aoa = NaN(length(PYc003.nk)+50,8);
    aoa(1:length(PYc001.nk),1) = PYc001.nk(:,l); % aoa_L
    aoa(1:length(PYc001.nk),2) = PYc001.nk(:,r); % aoa_R
    aoa(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % aoa_L %PYc003 needs shifting .5 wingbeat to align with others
    aoa(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % aoa_R %PYc003 needs shifting .5 wingbeat to align with others
    aoa(1:length(RBc005.nk),5) = RBc005.nk(:,l); % aoa_L
    aoa(1:length(RBc005.nk),6) = RBc005.nk(:,r); % aoa_R
    aoa(1:length(RBc006.nk),7) = RBc006.nk(:,l); % aoa_L
    aoa(1:length(RBc006.nk),8) = RBc006.nk(:,r); % aoa_R
    aoa_refmean = nanmean(aoa,2);
    aoa_refsd   = nanstd(aoa,0,2);
    
    % Body Roll
    roll = NaN(length(PYc003.nk)+50,4);
    roll(1:length(PYc001.nk),1) = PYc001.nk(:,11); % hnd_L
    roll(1:length(PYc003.nk(pshft:end,:)),2) = PYc003.nk(pshft:end,11); % hnd_L %PYc003 needs shifting .5 wingbeat to align with others
    roll(1:length(RBc005.nk),3) = RBc005.nk(:,11); % hnd_L
    roll(1:length(RBc006.nk),4) = RBc006.nk(:,11); % hnd_L
    roll_refmean = nanmean(roll,2);
    roll_refsd   = nanstd(roll,0,2);     
    
    % Body Pitch
    pitch = NaN(length(PYc003.nk)+pshft,4);
    pitch(1:length(PYc001.nk),1) = PYc001.nk(:,12); % hnd_L
    pitch(1:length(PYc003.nk(pshft:end,:)),2) = PYc003.nk(pshft:end,12); % hnd_L %PYc003 needs shifting .5 wingbeat to align with others
    pitch(1:length(RBc005.nk),3) = RBc005.nk(:,12); % hnd_L
    pitch(1:length(RBc006.nk),4) = RBc006.nk(:,12); % hnd_L
    pitch_refmean = nanmean(pitch,2);
    pitch_refsd   = nanstd(pitch,0,2);       
    
%% Plot Single Kinematic Variables for pulling data for statistical analysis
% Produce plot?
pl = 'y'

% Which Variable?
v = elev;

% Create wingbeat-normalized time-vector
nd = [.25:.01:3.5]';

% Plot the Variable for each trial
if pl == 'y'
  lw = 3;  
  figure
  subplot(2,1,1)
  plot(nd, v, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
  subplot(2,1,2)
  plot(nd, elev, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
end


%% Plot Mean Unperturbed Kinematics
nd = [.25:.01:3.5]';
x=[0 2.5];
n = 7;
figure
subplot(n,1,1) %Roll
plot(nd, roll_refmean, 'r'), hold on
plot(nd, roll_refmean+roll_refsd,'--k')
plot(nd, roll_refmean-roll_refsd,'--k')
plot(nd, pitch_refmean, 'b'), hold on
plot(nd, pitch_refmean+pitch_refsd,'--k')
plot(nd, pitch_refmean-pitch_refsd,'--k')
title({'Unperturbed Trials';'Body Orientation'}),box off
xlim(x)

subplot(n,1,2) %Humeral Elevation
plot(nd, elev_refmean), hold on
plot(nd, elev_refmean+elev_refsd,'--k')
plot(nd, elev_refmean-elev_refsd,'--k')
title('Humeral Elevation'),box off
xlim(x)

subplot(n,1,3) %Humeral Protraction
plot(nd, prot_refmean), hold on
plot(nd, prot_refmean+prot_refsd,'--k')
plot(nd, prot_refmean-prot_refsd,'--k')
title('Humeral Protraction'),box off
xlim(x)

subplot(n,1,4) %Wing Extension
plot(nd, ext_refmean), hold on
plot(nd, ext_refmean+ext_refsd,'--k')
plot(nd, ext_refmean-ext_refsd,'--k')
title('Wing Extension'),box off
xlim(x)

subplot(n,1,5) %Elbow Angle
plot(nd, elb_refmean), hold on
plot(nd, elb_refmean+elb_refsd,'--k')
plot(nd, elb_refmean-elb_refsd,'--k')
title('Elbow Extension'),box off
xlim(x)

subplot(n,1,6) %Handwing Abduction Angle
plot(nd, hnd_refmean), hold on
plot(nd, hnd_refmean+hnd_refsd,'--k')
plot(nd, hnd_refmean-hnd_refsd,'--k')
title('Handwing Abduction'), box off
xlim(x)

subplot(n,1,7) %Angle of Attack
plot(nd, aoa_refmean), hold on
plot(nd, aoa_refmean+hnd_refsd,'--k')
plot(nd, aoa_refmean-hnd_refsd,'--k')
title('Angle of Attack'), box off
xlim(x)

    %% Asymmetry measurement
    pshft = 50;
    
    % Ext_asym
    k=1;
    ext_asymref = NaN(length(PYc003.nk)+50,4);
    ext_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    ext_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    ext_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    ext_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    ext_asymrefmean = nanmean(ext_asymref,2);
    ext_asymrefsd   = nanstd(ext_asymref,0,2);  

    % Elev_asym
    k=2;
    elev_asymref = NaN(length(PYc003.nk)+50,4);
    elev_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    elev_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    elev_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    elev_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    elev_asymrefmean = nanmean(elev_asymref,2);
    elev_asymrefsd   = nanstd(elev_asymref,0,2);      

%     %% test
%     k=2;
%     test = NaN(length(PYc003.nk)+50,4);
%     test(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
%     test(1+50:length(PYc003.asym)+50,2) = PYc003.asym(:,k); % ext_L
%     test(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
%     test(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
%     test_asymrefmean = nanmean(test,2);
%     test_asymrefsd   = nanstd(test,0,2); 
% 
% 
% var = test;
% varmean = test_asymrefmean;
% varsd = test_asymrefsd;
% k=2;
% figure, hold on
% % shift=-.32; % shift control data along x-axis
% plot(varmean,'k','linewidth',3)
% plot(varmean+varsd,'--k')
% plot(varmean-varsd,'--k')
% plot(var)
% legend('RefMean','RefSD','RefSD','PYc001','PYc003','RBc005','RBc006')
% 

  
    % Prot_asym
    k=3;
    prot_asymref = NaN(length(PYc003.nk)+50,4);
    prot_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    prot_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    prot_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    prot_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    prot_asymrefmean = nanmean(prot_asymref,2);
    prot_asymrefsd   = nanstd(prot_asymref,0,2); 
    
    % Elb_asym
    k=4;
    elb_asymref = NaN(length(PYc003.nk)+50,4);
    elb_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    elb_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    elb_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    elb_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    elb_asymrefmean = nanmean(elb_asymref,2);
    elb_asymrefsd   = nanstd(elb_asymref,0,2);   
    
    % Hnd_asym
    k=5;
    hnd_asymref = NaN(length(PYc003.nk)+50,4);
    hnd_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    hnd_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    hnd_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    hnd_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    hnd_asymrefmean = nanmean(hnd_asymref,2);
    hnd_asymrefsd   = nanstd(hnd_asymref,0,2);
    
    % Aoa_asym
    k=6;
    aoa_asymref = NaN(length(PYc003.nk)+50,4);
    aoa_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    aoa_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    aoa_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    aoa_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    aoa_asymrefmean = nanmean(aoa_asymref,2);
    aoa_asymrefsd   = nanstd(aoa_asymref,0,2);
    
    
    % Concatenate mean/sd Reference Data
    % Mean Reference Data
        % refmean(:,1) = wing extension
        % refmean(:,2) = humeral elevation, i.e. elevation
        % refmean(:,3) = humeral protraction/retracion, i.e. sweep
        % refmean(:,4) = elbow angle
        % refmean(:,5) = handwing spread
        
        asymrefmean = NaN(length(ext_asymrefmean),6);
        asymrefmean(:,1) = ext_asymrefmean;
        asymrefmean(:,2) = elev_asymrefmean;
        asymrefmean(:,3) = prot_asymrefmean;
        asymrefmean(:,4) = elb_asymrefmean;
        asymrefmean(:,5) = hnd_asymrefmean;
        asymrefmean(:,6) = aoa_asymrefmean;
        
           
        asymrefsd = NaN(length(ext_asymrefsd),6);
        asymrefsd(:,1) = ext_asymrefsd;
        asymrefsd(:,2) = elev_asymrefsd;
        asymrefsd(:,3) = prot_asymrefsd;
        asymrefsd(:,4) = elb_asymrefsd;
        asymrefsd(:,5) = hnd_asymrefsd;
        asymrefsd(:,6) = aoa_asymrefsd;
        
%% Plot asym
k=1;
var = ext_asymref;
figure, hold on
% shift=-.32; % shift control data along x-axis
plot(asymrefmean(:,k),'k','linewidth',3)
plot(asymrefmean(:,k)+asymrefsd(:,k),'--k')
plot(asymrefmean(:,k)-asymrefsd(:,k),'--k')
plot(var)
legend('RefMean','RefSD','RefSD','PYc001','PYc003','RBc005','RBc006')

%% Load Perturbed Data
PYg_006 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/PYg006.mat',vars{:});
PY_g017 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/PYg017.mat',vars{:});
RBg_011 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/RBg011.mat',vars{:});
RBg_012 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/RBg012.mat',vars{:});
GG_g002 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/GGg002.mat',vars{:});
GG_g021 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/GGg021.mat',vars{:});
GG_g007 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/GGg007.mat',vars{:});
BG_g004 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/BGg004.mat',vars{:});
% BG_g010 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Body Perturbations/BGg010.mat',vars{:});

num_trl = 8;
    % Humeral Elevation & Depression
    l=3; r=4;
    elev_pert = NaN(400,num_trl*2);
    elev_pert(1:length(PYg_006.nk),1)  = PYg_006.nk(:,l); % elev_L
    elev_pert(1:length(PYg_006.nk),2)  = PYg_006.nk(:,r); % elev_R
    elev_pert(1:length(PY_g017.nk),3)  = PY_g017.nk(:,l); % elev_L
    elev_pert(1:length(PY_g017.nk),4)  = PY_g017.nk(:,r); % elev_R
    elev_pert(1:length(RBg_011.nk),5)  = RBg_011.nk(:,l); % elev_L
    elev_pert(1:length(RBg_011.nk),6)  = RBg_011.nk(:,r); % elev_R
    elev_pert(1:length(RBg_012.nk),7)  = RBg_012.nk(:,l); % elev_L
    elev_pert(1:length(RBg_012.nk),8)  = RBg_012.nk(:,r); % elev_R
    elev_pert(1:length(GG_g002.nk),9)  = GG_g002.nk(:,l); % elev_L
    elev_pert(1:length(GG_g002.nk),10) = GG_g002.nk(:,r); % elev_R
    elev_pert(1:length(GG_g021.nk),11) = GG_g021.nk(:,l); % elev_L
    elev_pert(1:length(GG_g021.nk),12) = GG_g021.nk(:,r); % elev_R
    elev_pert(1:length(GG_g007.nk),13) = GG_g007.nk(:,l); % elev_L
    elev_pert(1:length(GG_g007.nk),14) = GG_g007.nk(:,r); % elev_R
    elev_pert(1:length(BG_g004.nk),15) = BG_g004.nk(:,l); % elev_L
    elev_pert(1:length(BG_g004.nk),16) = BG_g004.nk(:,r); % elev_R
    elev_pert(elev_pert==0)=NaN;
    elev_pertmean = nanmean(elev_pert,2);
    elev_pertsd   = nanstd(elev_pert,0,2);
    
    % Humeral Protraction & Retraction
    l=5; r=6;
    prot_pert = NaN(400,num_trl*2);
    prot_pert(1:length(PYg_006.nk),1)  = PYg_006.nk(:,l); % Prot_L
    prot_pert(1:length(PYg_006.nk),2)  = PYg_006.nk(:,r); % Prot_R
    prot_pert(1:length(PY_g017.nk),3)  = PY_g017.nk(:,l); % Prot_L
    prot_pert(1:length(PY_g017.nk),4)  = PY_g017.nk(:,r); % Prot_R
    prot_pert(1:length(RBg_011.nk),5)  = RBg_011.nk(:,l); % Prot_L
    prot_pert(1:length(RBg_011.nk),6)  = RBg_011.nk(:,r); % Prot_R
    prot_pert(1:length(RBg_012.nk),7)  = RBg_012.nk(:,l); % Prot_L
    prot_pert(1:length(RBg_012.nk),8)  = RBg_012.nk(:,r); % Prot_R
    prot_pert(1:length(GG_g002.nk),9)  = GG_g002.nk(:,l); % Prot_L
    prot_pert(1:length(GG_g002.nk),10) = GG_g002.nk(:,r); % Prot_R
    prot_pert(1:length(GG_g021.nk),11) = GG_g021.nk(:,l); % Prot_L
    prot_pert(1:length(GG_g021.nk),12) = GG_g021.nk(:,r); % Prot_R
    prot_pert(1:length(GG_g007.nk),13) = GG_g007.nk(:,l); % Prot_L
    prot_pert(1:length(GG_g007.nk),14) = GG_g007.nk(:,r); % Prot_R
    prot_pert(1:length(BG_g004.nk),15) = BG_g004.nk(:,l); % Prot_L
    prot_pert(1:length(BG_g004.nk),16) = BG_g004.nk(:,r); % Prot_R
    prot_pert(prot_pert==0)=NaN;
    prot_pertmean = nanmean(prot_pert,2);
    prot_pertsd   = nanstd(prot_pert,0,2);
    
    % Elbow Flexion & Extension
    l=7; r=8;
    elb_pert = NaN(400,num_trl*2);
    elb_pert(1:length(PYg_006.nk),1)  = PYg_006.nk(:,l); % Elb_L
    elb_pert(1:length(PYg_006.nk),2)  = PYg_006.nk(:,r); % Elb_R
    elb_pert(1:length(PY_g017.nk),3)  = PY_g017.nk(:,l); % Elb_L
    elb_pert(1:length(PY_g017.nk),4)  = PY_g017.nk(:,r); % Elb_R
    elb_pert(1:length(RBg_011.nk),5)  = RBg_011.nk(:,l); % Elb_L
    elb_pert(1:length(RBg_011.nk),6)  = RBg_011.nk(:,r); % Elb_R
    elb_pert(1:length(RBg_012.nk),7)  = RBg_012.nk(:,l); % Elb_L
    elb_pert(1:length(RBg_012.nk),8)  = RBg_012.nk(:,r); % Elb_R
    elb_pert(1:length(GG_g002.nk),9)  = GG_g002.nk(:,l); % Elb_l
    elb_pert(1:length(GG_g002.nk),10) = GG_g002.nk(:,r); % Elb_R
    elb_pert(1:length(GG_g021.nk),11) = GG_g021.nk(:,l); % Elb_l
    elb_pert(1:length(GG_g021.nk),12) = GG_g021.nk(:,r); % Elb_R
    elb_pert(1:length(GG_g007.nk),13) = GG_g007.nk(:,l); % Elb_l
    elb_pert(1:length(GG_g007.nk),14) = GG_g007.nk(:,r); % Elb_R
    elb_pert(1:length(BG_g004.nk),15) = BG_g004.nk(:,l); % Prot_L
    elb_pert(1:length(BG_g004.nk),16) = BG_g004.nk(:,r); % Elb_l
    elb_pert(elb_pert==0)=NaN;
    elb_pertmean = nanmean(elb_pert,2);
    elb_pertsd   = nanstd(elb_pert,0,2);  
   
    % Wing Extension & Folding
    l=1; r=2;
    ext_pert = NaN(400,num_trl*2);
    ext_pert(1:length(PYg_006.nk),1)  = PYg_006.nk(:,l); % Ext_L
    ext_pert(1:length(PYg_006.nk),2)  = PYg_006.nk(:,r); % Ext_R
    ext_pert(1:length(PY_g017.nk),3)  = PY_g017.nk(:,l); % Ext_L
    ext_pert(1:length(PY_g017.nk),4)  = PY_g017.nk(:,r); % Ext_R
    ext_pert(1:length(RBg_011.nk),5)  = RBg_011.nk(:,l); % Ext_L
    ext_pert(1:length(RBg_011.nk),6)  = RBg_011.nk(:,r); % Ext_R
    ext_pert(1:length(RBg_012.nk),7)  = RBg_012.nk(:,l); % Ext_L
    ext_pert(1:length(RBg_012.nk),8)  = RBg_012.nk(:,r); % Ext_R
    ext_pert(1:length(GG_g002.nk),9)  = GG_g002.nk(:,l); % Ext_R
    ext_pert(1:length(GG_g002.nk),10) = GG_g002.nk(:,r); % Ext_R
    ext_pert(1:length(GG_g021.nk),11) = GG_g021.nk(:,l); % Ext_R
    ext_pert(1:length(GG_g021.nk),12) = GG_g021.nk(:,r); % Ext_R
    ext_pert(1:length(GG_g007.nk),13) = GG_g007.nk(:,l); % Ext_L
    ext_pert(1:length(GG_g007.nk),14) = GG_g007.nk(:,r); % Ext_R
    ext_pert(1:length(BG_g004.nk),15) = BG_g004.nk(:,l); % Ext_L
    ext_pert(1:length(BG_g004.nk),16) = BG_g004.nk(:,r); % Ext_R
    ext_pert(ext_pert==0)=NaN;
    ext_pertmean = nanmean(ext_pert,2);
    ext_pertsd   = nanstd(ext_pert,0,2);    
   
    % Handwing Spreading
    l=9; r=10;
    hnd_pert = NaN(400,num_trl*2);
    hnd_pert(1:length(PYg_006.nk),1)  = PYg_006.nk(:,l); % Hnd_L
    hnd_pert(1:length(PYg_006.nk),2)  = PYg_006.nk(:,r); % Hnd_R
    hnd_pert(1:length(PY_g017.nk),3)  = PY_g017.nk(:,l); % Hnd_L
    hnd_pert(1:length(PY_g017.nk),4)  = PY_g017.nk(:,r); % Hnd_R
    hnd_pert(1:length(RBg_011.nk),5)  = RBg_011.nk(:,l); % Hnd_L
    hnd_pert(1:length(RBg_011.nk),6)  = RBg_011.nk(:,r); % Hnd_R
    hnd_pert(1:length(RBg_012.nk),7)  = RBg_012.nk(:,l); % Hnd_L
    hnd_pert(1:length(RBg_012.nk),8)  = RBg_012.nk(:,r); % Hnd_R
    hnd_pert(1:length(GG_g002.nk),9)  = GG_g002.nk(:,l); % Hnd_R
    hnd_pert(1:length(GG_g002.nk),10) = GG_g002.nk(:,r); % Hnd_R
    hnd_pert(1:length(GG_g021.nk),11) = GG_g021.nk(:,l); % Hnd_R
    hnd_pert(1:length(GG_g021.nk),12) = GG_g021.nk(:,r); % Hnd_R
    hnd_pert(1:length(GG_g007.nk),13) = GG_g007.nk(:,l); % Ext_L
    hnd_pert(1:length(GG_g007.nk),14) = GG_g007.nk(:,r); % Hnd_R
    hnd_pert(1:length(BG_g004.nk),15) = BG_g004.nk(:,l); % Ext_L
    hnd_pert(1:length(BG_g004.nk),16) = BG_g004.nk(:,r); % Hnd_R
    hnd_pert(hnd_pert==0)=NaN;
    hnd_pertmean = nanmean(hnd_pert,2);
    hnd_pertsd   = nanstd(hnd_pert,0,2);    
    
    % Angle of Attack
    l=18; r=19;
    aoa_pert = NaN(400,num_trl*2);
    aoa_pert(1:length(PYg_006.nk),1)  = PYg_006.nk(:,l); % aoa_L
    aoa_pert(1:length(PYg_006.nk),2)  = PYg_006.nk(:,r); % aoa_R
    aoa_pert(1:length(PY_g017.nk),3)  = PY_g017.nk(:,l); % aoa_L
    aoa_pert(1:length(PY_g017.nk),4)  = PY_g017.nk(:,r); % aoa_R
%     aoa_pert(1:length(RBg_011.nk),5)  = RBg_011.nk(:,l); % aoa_L
%     aoa_pert(1:length(RBg_011.nk),6)  = RBg_011.nk(:,r); % aoa_R
%     aoa_pert(1:length(RBg_012.nk),7)  = RBg_012.nk(:,l); % aoa_L
%     aoa_pert(1:length(RBg_012.nk),8)  = RBg_012.nk(:,r); % aoa_R
%     aoa_pert(1:length(GG_g002.nk),9)  = GG_g002.nk(:,l); % aoa_R
%     aoa_pert(1:length(GG_g002.nk),10) = GG_g002.nk(:,r); % aoa_R
    aoa_pert(1:length(GG_g021.nk),11) = GG_g021.nk(:,l); % aoa_R
    aoa_pert(1:length(GG_g021.nk),12) = GG_g021.nk(:,r); % aoa_R
    aoa_pert(1:length(GG_g007.nk),13) = GG_g007.nk(:,l); % aoa_L
    aoa_pert(1:length(GG_g007.nk),14) = GG_g007.nk(:,r); % aoa_R
    aoa_pert(1:length(BG_g004.nk),15) = BG_g004.nk(:,l); % aoa_L
    aoa_pert(1:length(BG_g004.nk),16) = BG_g004.nk(:,r); % aoa_R
    aoa_pert(aoa_pert==0)=NaN;
    aoa_pertmean = nanmean(aoa_pert,2);
    aoa_pertsd   = nanstd(aoa_pert,0,2);
   
    % Body Roll
    k=11;
    roll_pert = NaN(400,num_trl*2);
    roll_pert(1:length(PYg_006.nk),1) = PYg_006.nk(:,k); % Roll
    roll_pert(1:length(PY_g017.nk),2) = PY_g017.nk(:,k); % Roll
    roll_pert(1:length(RBg_011.nk),3) = RBg_011.nk(:,k); % Roll
    roll_pert(1:length(RBg_012.nk),4) = RBg_012.nk(:,k); % Roll
    roll_pert(1:length(GG_g002.nk),5) = GG_g002.nk(:,k); % Roll
    roll_pert(1:length(GG_g021.nk),6) = GG_g021.nk(:,k); % Roll
    roll_pert(1:length(GG_g007.nk),7) = GG_g007.nk(:,k); % Roll
    roll_pert(1:length(BG_g004.nk),8) = BG_g004.nk(:,k); % Roll
    roll_pert(roll_pert==0)=NaN;
    roll_pertmean = nanmean(roll_pert,2);
    roll_pertsd   = nanstd(roll_pert,0,2);       
   
    % Body Pitch
    k=12;
    pitch_pert = NaN(400,num_trl*2);
    pitch_pert(1:length(PYg_006.nk),1) = PYg_006.nk(:,k); % Roll
    pitch_pert(1:length(PY_g017.nk),2) = PY_g017.nk(:,k); % Roll
    pitch_pert(1:length(RBg_011.nk),3) = RBg_011.nk(:,k); % Roll
    pitch_pert(1:length(RBg_012.nk),4) = RBg_012.nk(:,k); % Roll
    pitch_pert(1:length(GG_g002.nk),5) = GG_g002.nk(:,k); % Roll
    pitch_pert(1:length(GG_g021.nk),6) = GG_g021.nk(:,k); % Roll
    pitch_pert(1:length(GG_g007.nk),7) = GG_g007.nk(:,k); % Roll
    pitch_pert(1:length(BG_g004.nk),8) = BG_g004.nk(:,k); % Roll
    pitch_pert(pitch_pert==0)=NaN;
    pitch_pertmean = nanmean(pitch_pert,2);
    pitch_pertsd   = nanstd(pitch_pert,0,2);   
    
%% Plot Humeral Elevation and Gust timing for each trial
l = 3;
r = 4;
figure,hold on
% plot(zz(:,1),'b'),hold on
% plot(zz(:,2),'r')
% plot(shift/3+1:length(RBg007.nk)+shift/3,RBg007.nk(:,17))
% title('RBg007') 
plot(PYg_006.nk(:,l),'b') 
plot(PYg_006.nk(:,r),'r')
plot(PYg_006.nk(:,17))
title('PYg_006')


figure,hold on
% plot(zz(:,3),'b'),hold on
% plot(zz(:,4),'r')
% plot(shift/3+1:length(PYg001.nk)+shift/3,PYg001.nk(:,17))
plot(PY_g017.nk(:,l),'b')
plot(PY_g017.nk(:,r),'r')
plot(PY_g017.nk(:,17))
title('PY_g017')

figure,hold on
% plot(zz(:,5),'b'),hold on
% plot(zz(:,6),'r')
% plot(shift+1:length(PYg002.nk)+shift,PYg002.nk(:,17))
plot(RBg_011.nk(:,l),'b')
plot(RBg_011.nk(:,r),'r')
plot(RBg_011.nk(:,17))
title('RBg_011')

figure,hold on
% plot(zz(:,7),'b'),hold on
% plot(zz(:,8),'r')
% plot(shift+1:length(PYg016.nk)+shift,PYg016.nk(:,17))
plot(RBg_012.nk(:,l),'b')
plot(RBg_012.nk(:,r),'r')
plot(RBg_012.nk(:,17))
title('RBg_012')

figure,hold on
% plot(zz(:,9),'b'),hold on
% plot(zz(:,10),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg008.nk(:,17))
plot(GG_g002.nk(:,l),'b')
plot(GG_g002.nk(:,r),'r')
plot(GG_g002.nk(:,17))
title('GG_g002')

figure,hold on
% plot(zz(:,11),'b'),hold on
% plot(zz(:,12),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
plot(GG_g021.nk(:,l),'b')
plot(GG_g021.nk(:,r),'r')
plot(GG_g021.nk(:,17))
title('GG_g021')

figure,hold on
% plot(zz(:,11),'b'),hold on
% plot(zz(:,12),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
plot(GG_g007.nk(:,l),'b')
plot(GG_g007.nk(:,r),'r')
plot(GG_g007.nk(:,17))
title('GG_g007')

figure,hold on
% plot(zz(:,11),'b'),hold on
% plot(zz(:,12),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
plot(BG_g004.nk(:,l),'b')
plot(BG_g004.nk(:,r),'r')
plot(BG_g004.nk(:,17))
title('BG_g004')

%% Plot Humeral Elevation and Gust timing for each trial
l = 3;
r = 4;
figure,hold on
% plot(zz(:,1),'b'),hold on
% plot(zz(:,2),'r')
% plot(shift/3+1:length(RBg007.nk)+shift/3,RBg007.nk(:,17))
% title('RBg007') 
plot(PYg_006.nk(:,l),'b') 
plot(PYg_006.nk(:,r),'r')
plot(PYg_006.nk(:,17)*.09)
title('PYg_006')


figure,hold on
% plot(zz(:,3),'b'),hold on
% plot(zz(:,4),'r')
% plot(shift/3+1:length(PYg001.nk)+shift/3,PYg001.nk(:,17))
plot(PY_g017.nk(:,l),'b')
plot(PY_g017.nk(:,r),'r')
plot(PY_g017.nk(:,17)*.09)
title('PY_g017')

figure,hold on
% plot(zz(:,5),'b'),hold on
% plot(zz(:,6),'r')
% plot(shift+1:length(PYg002.nk)+shift,PYg002.nk(:,17))
plot(RBg_011.nk(:,l),'b')
plot(RBg_011.nk(:,r),'r')
plot(RBg_011.nk(:,17)*.09)
title('RBg_011')

figure,hold on
% plot(zz(:,7),'b'),hold on
% plot(zz(:,8),'r')
% plot(shift+1:length(PYg016.nk)+shift,PYg016.nk(:,17))
plot(RBg_012.nk(:,l),'b')
plot(RBg_012.nk(:,r),'r')
plot(RBg_012.nk(:,17)*.09)
title('RBg_012')

figure,hold on
% plot(zz(:,9),'b'),hold on
% plot(zz(:,10),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg008.nk(:,17))
plot(GG_g002.nk(:,l),'b')
plot(GG_g002.nk(:,r),'r')
plot(GG_g002.nk(:,17)*.09)
title('GG_g002')

figure,hold on
% plot(zz(:,11),'b'),hold on
% plot(zz(:,12),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
plot(GG_g021.nk(:,l),'b')
plot(GG_g021.nk(:,r),'r')
plot(GG_g021.nk(:,17)*.09)
title('GG_g021')

figure,hold on
% plot(zz(:,11),'b'),hold on
% plot(zz(:,12),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
plot(GG_g007.nk(:,l),'b')
plot(GG_g007.nk(:,r),'r')
plot(GG_g007.nk(:,17)*.09)
title('GG_g007')

figure,hold on
% plot(zz(:,11),'b'),hold on
% plot(zz(:,12),'r')
% plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
plot(BG_g004.nk(:,l),'b')
plot(BG_g004.nk(:,r),'r')
plot(BG_g004.nk(:,17)*.09)
title('BG_g004')

%% Shift Data so that 1st bottom-of-DS after gust is at x=150 (EXCEPT RBg012 and GGg007)
% Shift is from data contained in each trial's .nk matrix
shft = [  0    %PYg_006
         50    %PY_g017
         50    %RBg_011
         75    %RBg_012 
         50    %GG_g002
         50    %GG_g021
         75    %GG_g007 
        100];  %BG_g004
              
% Gust-aligned kinematic data 
ga = NaN(400,num_trl*2,7);

% Wing Extension
l = 1; % kinematic data for left wing
r = 2; % kinematic data for right wing
j=1;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1:2,j)   = PYg_006.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),3:4,j)   = PY_g017.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),5:6,j)   = RBg_011.nk(:,l:r); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),7:8,j)   = RBg_012.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),9:10,j)  = GG_g002.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),11:12,j) = GG_g021.nk(:,l:r); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),13:14,j) = GG_g007.nk(:,l:r); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),15:16,j) = BG_g004.nk(:,l:r); clear k

% Humeral Elevation
l = 3; % kinematic data for left wing
r = 4; % kinematic data for right wing
j=2;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1:2,j) = PYg_006.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),3:4,j) = PY_g017.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),5:6,j) = RBg_011.nk(:,l:r); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),7:8,j) = RBg_012.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),9:10,j) = GG_g002.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),11:12,j) = GG_g021.nk(:,l:r); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),13:14,j) = GG_g007.nk(:,l:r); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),15:16,j) = BG_g004.nk(:,l:r); clear k

% Humeral Protraction
l = 5; % kinematic data for left wing
r = 6; % kinematic data for right wing
j=3;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1:2,j) = PYg_006.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),3:4,j) = PY_g017.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),5:6,j) = RBg_011.nk(:,l:r); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),7:8,j) = RBg_012.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),9:10,j) = GG_g002.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),11:12,j) = GG_g021.nk(:,l:r); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),13:14,j) = GG_g007.nk(:,l:r); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),15:16,j) = BG_g004.nk(:,l:r); clear k

% Elbow Angle
l = 7; % kinematic data for left wing
r = 8; % kinematic data for right wing
j=4;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1:2,j) = PYg_006.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),3:4,j) = PY_g017.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),5:6,j) = RBg_011.nk(:,l:r); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),7:8,j) = RBg_012.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),9:10,j) = GG_g002.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),11:12,j) = GG_g021.nk(:,l:r); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),13:14,j) = GG_g007.nk(:,l:r); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),15:16,j) = BG_g004.nk(:,l:r); clear k

% hand Spread
l = 9; % kinematic data for left wing
r = 10; % kinematic data for right wing
j=5;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1:2,j) = PYg_006.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),3:4,j) = PY_g017.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),5:6,j) = RBg_011.nk(:,l:r); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),7:8,j) = RBg_012.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),9:10,j) = GG_g002.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),11:12,j) = GG_g021.nk(:,l:r); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),13:14,j) = GG_g007.nk(:,l:r); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),15:16,j) = BG_g004.nk(:,l:r); clear k

% Angle of Attack
l = 18; % kinematic data for left wing
r = 19; % kinematic data for right wing
j=6;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1:2,j) = PYg_006.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),3:4,j) = PY_g017.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),5:6,j) = RBg_011.nk(:,l:r); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),7:8,j) = RBg_012.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),9:10,j) = GG_g002.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),11:12,j) = GG_g021.nk(:,l:r); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),13:14,j) = GG_g007.nk(:,l:r); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),15:16,j) = BG_g004.nk(:,l:r); clear k

% Body Pitch
j=7;
p=12;
k=1; ga(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.nk(:,p); clear k
k=2; ga(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.nk(:,p); clear k
k=3; ga(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.nk(:,p); clear k
% k=4; ga(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.nk(:,p); clear k
k=5; ga(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.nk(:,p); clear k
k=6; ga(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.nk(:,p); clear k
% k=7; ga(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.nk(:,p); clear k
k=8; ga(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.nk(:,p); clear k

ga(ga==0) = NaN;


%% Calculate meanSD wingbeat kinematics and plot to compare to unperturbed kinemtics
figure
xlm=[1, 3];
n=7; % number of plots in subplot
shift=0.5; % shift control data along x-axis
% Body Pitch
k=7;
pert_mean = nanmean(-ga(:,:,k),2);
pert_sd = nanstd(-ga(:,:,k),0,2);
refmean = -pitch_refmean;
refsd = -pitch_refsd;
subplot(n,1,1)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Pitch'), box off, xlim(xlm);

% Humeral Elevation
k=2;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = elev_refmean;
refsd = elev_refsd;
subplot(n,1,2)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Humeral Elevation'), box off
ylim([-75 75]), xlim(xlm);

% Humeral Retraction
k=3;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = prot_refmean;
refsd = prot_refsd;
subplot(n,1,3)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Humeral Retraction'), box off
ylim([50 200]), xlim(xlm);

% Wing Extension
k=1;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = ext_refmean;
refsd = ext_refsd;
subplot(n,1,4)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Wing Extension'), box off
ylim([.3 1.2]), xlim(xlm);
  
% Elbow Extension
k=4;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = elb_refmean;
refsd = elb_refsd;
subplot(n,1,5)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Elbow Extension'), box off
ylim([0 150]), xlim(xlm);

% Handwing Abduction
k=5;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = hnd_refmean;
refsd = hnd_refsd;
subplot(n,1,6)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Handwing Abduction'), box off
ylim([50 175]), xlim(xlm);

% Angle of Attack
k=6;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = aoa_refmean;
refsd = aoa_refsd;
subplot(n,1,7)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Angle of Attack'), box off
ylim([-50 100]), xlim(xlm);

%% Plot other variables for checking:
% Plot Humeral elevation/depression to check that up/downstrokes align between perturbed and reference data
figure
hold on
plot(nd+.5,elev_refmean,'k','linewidth',3)
plot(nd+.5,elev_refmean+elev_refsd,'--k')
plot(nd+.5,elev_refmean-elev_refsd,'--k')
plot(0:.01:(.01*length(ga)-.01),ga(:,:,2))
legend('RefMean','RefSD','RefSD','pyg06L','pyg06R','pyg17L','pyg17R','rbg11L','rbg11R','rbg12L','rbg12R','ggg02L','ggg02R','ggg21L','ggg21R','ggg07L','ggg07R','bgg04L','bgg04R')

% Pitch
figure
hold on
plot(nd+.5,-pitch_refmean,'k','linewidth',3)
plot(nd+.5,-pitch_refmean+(-pitch_refsd),'--k')
plot(nd+.5,-pitch_refmean-(-pitch_refsd),'--k')
plot(0:.01:(.01*length(ga)-.01),ga(:,:,7))
legend('RefMean','RefSD','RefSD','pyg06','pyg17','rbg11','rbg12','ggg02','ggg21','ggg07','bgg04')
title('Pitch')

j = 1;
refmean = ext_refmean;
refsd  = ext_refsd;
figure
hold on
plot(nd+.5,refmean,'k','linewidth',3)
plot(nd+.5,refmean+refsd,'--k')
plot(nd+.5,refmean-refsd,'--k')
plot(0:.01:(.01*length(ga)-.01),ga(:,:,j))
legend('RefMean','RefSD','RefSD','pyg06L','pyg06R','pyg17L','pyg17R','rbg11L','rbg11R','rbg12L','rbg12R','ggg02L','ggg02R','ggg21L','ggg21R','ggg07L','ggg07R','bgg04L','bgg04R')

% % Plot average wing extension (with RBg012, and GGg007 thrown out . . . their wingbeat timing w/r/t the end of the perturbation is not the same as other trials, I think)
% ext_ga = ga(:,:,j);
% ext_ga_DS = NaN(size(ga,1),6); 
% ext_ga_DS(:,1:2) = ext_ga(:,7:8); ext_ga(:,7:8) = NaN; % remove RBg012 [ga(:,7:8)]
% ext_ga_DS(:,3:4) = ext_ga(:,13:14); ext_ga(:,13:14) = NaN; % remove GGg007 [ga(:,13:14)]
% 
% ext_ga_pertmean = nanmean(ext_ga(:,:,j),2);
% ext_ga_pertsd   = nanstd(ext_ga(:,:,j),0,2);
% figure
% hold on
% plot(nd+.5,refmean,'k','linewidth',3)
% plot(nd+.5,refmean+refsd,'--k')
% plot(nd+.5,refmean-refsd,'--k')
% plot(0:.01:(.01*length(ext_ga)-.01),ext_ga_pertmean,'r')
% plot(0:.01:(.01*length(ext_ga)-.01),ext_ga_pertmean+ext_ga_pertsd,'--r')
% plot(0:.01:(.01*length(ext_ga)-.01),ext_ga_pertmean-+ext_ga_pertsd,'--r')
% 
% ext_ga_DSmean = nanmean(ext_ga_DS(:,:,j),2);
% ext_ga_DSsd   = nanstd(ext_ga_DS(:,:,j),0,2);
% figure
% hold on
% plot(nd+.5,refmean,'k','linewidth',3)
% plot(nd+.5,refmean+refsd,'--k')
% plot(nd+.5,refmean-refsd,'--k')
% plot(0:.01:(.01*length(ext_ga_DS)-.01),ext_ga_DSmean,'r')
% plot(0:.01:(.01*length(ext_ga_DS)-.01),ext_ga_DSmean+ext_ga_DSsd,'--r')
% plot(0:.01:(.01*length(ext_ga_DS)-.01),ext_ga_DSmean-+ext_ga_DSsd,'--r')
% title('DS-gust-end trials')

%% Gust-aligned asymmetry data
ga_asym = NaN(400,num_trl,5);

% extension asymmetry data
j=1;
p=1;
k=1; ga_asym(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.asym(:,p); clear k
% k=4; ga_asym(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.asym(:,p); clear k
% k=7; ga_asym(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.asym(:,p); clear k
k=8; ga_asym(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.asym(:,p); clear k

% humeral elevation asymmetry data
j=2;
p=2;
k=1; ga_asym(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.asym(:,p); clear k
% k=4; ga_asym(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.asym(:,p); clear k
% k=7; ga_asym(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.asym(:,p); clear k
k=8; ga_asym(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.asym(:,p); clear k

% humeral protraction asymmetry data
j=3;
p=3;
k=1; ga_asym(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.asym(:,p); clear k
% k=4; ga_asym(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.asym(:,p); clear k
% k=7; ga_asym(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.asym(:,p); clear k
k=8; ga_asym(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.asym(:,p); clear k

% Elbow angle asymmetry data
j=4;
p=4;
k=1; ga_asym(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.asym(:,p); clear k
% k=4; ga_asym(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.asym(:,p); clear k
% k=7; ga_asym(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.asym(:,p); clear k
k=8; ga_asym(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.asym(:,p); clear k

% handwing spread asymmetry data
j=5;
p=5;
k=1; ga_asym(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.asym(:,p); clear k
% k=4; ga_asym(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.asym(:,p); clear k
% k=7; ga_asym(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.asym(:,p); clear k
k=8; ga_asym(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.asym(:,p); clear k

% angle of attack asymmetry data
j=6;
p=5;
k=1; ga_asym(shft(k)+1:length(PYg_006.nk)+shft(k),1,j) = PYg_006.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PY_g017.nk)+shft(k),2,j) = PY_g017.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(RBg_011.nk)+shft(k),3,j) = RBg_011.asym(:,p); clear k
% k=4; ga_asym(shft(k)+1:length(RBg_012.nk)+shft(k),4,j) = RBg_012.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GG_g002.nk)+shft(k),5,j) = GG_g002.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GG_g021.nk)+shft(k),6,j) = GG_g021.asym(:,p); clear k
% k=7; ga_asym(shft(k)+1:length(GG_g007.nk)+shft(k),7,j) = GG_g007.asym(:,p); clear k
k=8; ga_asym(shft(k)+1:length(BG_g004.nk)+shft(k),8,j) = BG_g004.asym(:,p); clear k

ga_asym(ga_asym==0)=NaN;


%% Plot Single Kinematic Variables for pulling data for statistical analysis
% Produce plot?
pl = 'y'

% Which Variable?
v = ga(51:end,:,2);

% Create wingbeat-normalized time-vector
ndg = [.25:.01:3.26]';
ndc = [0:.01:3.5]';
% Plot the Variable for each trial
if pl == 'y'
  lw = 3;  
  figure
  subplot(2,1,1)
  plot(ndc , v, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
  subplot(2,1,2)
  plot(nd, elev, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
end


%% Calculate average asymmetries across trials
% Multiplot: change k to change plotted kinematic variable
figure, hold on
k=2;
shift=0.5; % shift control data along x-axis
plot(nd+shift,asymrefmean(:,k),'k','linewidth',3)
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')
plot(0:.01:(.01*length(ga_asym)-.01),ga_asym(:,:,k))
legend('RefMean','RefSD','RefSD','pyg06','pyg17','rbg11','rbg12','ggg02','ggg21','ggg07','bgg04')

% Big plot
figure
n=7;
% Body Pitch
k=7;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = pitch_refmean;
refsd = pitch_refsd;
subplot(n,1,1)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Pitch'), box off
ylim([-50 50]), xlim(xlm);

% Average Humeral Elevation Asymmetry
k=2;
avg_elev = nanmean(ga_asym(:,:,k),2);
avg_elev_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,2)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_elev)-.01),avg_elev,'k','linewidth',3)
plot(0:.01:(.01*length(avg_elev)-.01),avg_elev+avg_elev_sd,'--k')
plot(0:.01:(.01*length(avg_elev)-.01),avg_elev-avg_elev_sd,'--k')
title('Average Elevation Asymmetry'), box off
ylim([-10 50]), xlim(xlm);

% Average Retraction Asymmetry
k=3;
avg_prot = nanmean(ga_asym(:,:,k),2);
avg_prot_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,3)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_prot)-.01),avg_prot,'k','linewidth',3)
plot(0:.01:(.01*length(avg_prot)-.01),avg_prot+avg_prot_sd,'--k')
plot(0:.01:(.01*length(avg_prot)-.01),avg_prot-avg_prot_sd,'--k')
title('Average Retraction Asymmetry'), box off
ylim([-10 50]), xlim(xlm);

% Average Extension Asymmetry
k=1;
avg_ext = nanmean(ga_asym(:,:,k),2);
avg_ext_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,4)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_ext)-.01),avg_ext,'k','linewidth',3)
plot(0:.01:(.01*length(avg_ext)-.01),avg_ext+avg_ext_sd,'--k')
plot(0:.01:(.01*length(avg_ext)-.01),avg_ext-avg_ext_sd,'--k')
title('Average extension Asymmetry'), box off
ylim([-.10 .50]), xlim(xlm);

% Average Elbow Angle Asymmetry
k=4;
avg_elb = nanmean(ga_asym(:,:,k),2);
avg_elb_sd = nanstd(ga_asym(:,:,k),0,2);
y=[-10 70];
subplot(n,1,5)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_elb)-.01),avg_elb,'k','linewidth',3)
plot(0:.01:(.01*length(avg_elb)-.01),avg_elb+avg_elb_sd,'--k')
plot(0:.01:(.01*length(avg_elb)-.01),avg_elb-avg_elb_sd,'--k')
ylim(y)
title('Average Elbow Angle Asymmetry'), box off
ylim([-10 50]), xlim(xlm);


% Average Hand Spread Angle Asymmetry
k=5;
avg_hnd = nanmean(ga_asym(:,:,k),2);
avg_hnd_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,6)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd,'k','linewidth',3)
plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd+avg_hnd_sd,'--k')
plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd-avg_hnd_sd,'--k')
title('Average Hand Spread Angle Asymmetry'), box off
ylim([-10 80]), xlim(xlm);

% Average Angle of Attack Asymmetry
k=6;
avg_aoa = nanmean(ga_asym(:,:,k),2);
avg_aoa_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,7)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa,'k','linewidth',3)
plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa+avg_aoa_sd,'--k')
plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa-avg_aoa_sd,'--k')
title('Average Angle of Attack Asymmetry'), box off
ylim([-10 60]), xlim(xlm);


%% Plot Raw Daters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Kinematics %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
xlm=[1, 3];
n=7; % number of plots in subplot

% Body Pitch
k=7;
pert = -ga(:,:,k);
subplot(n,1,1)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Pitch'), box off, xlim(xlm);

% Humeral Elevation
k=2;
pert = ga(:,:,k);
subplot(n,1,2)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Humeral Elevation'), box off
ylim([-75 75]), xlim(xlm);

% Humeral Retraction
k=3;
pert = ga(:,:,k);
subplot(n,1,3)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Humeral Retraction'), box off
ylim([50 250]), xlim(xlm);

% Wing Extension
k=1;
pert = ga(:,:,k);
subplot(n,1,4)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Wing Extension'), box off
ylim([.3 1.2]), xlim(xlm);
  
% Elbow Extension
k=4;
pert = ga(:,:,k);
subplot(n,1,5)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Elbow Extension'), box off
ylim([0 150]), xlim(xlm);

% Handwing Abduction
k=5;
pert = ga(:,:,k);
subplot(n,1,6)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Handwing Abduction'), box off
ylim([50 175]), xlim(xlm);

% Angle of Attack
k=6;
pert = ga(:,:,k);
subplot(n,1,7)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Angle of Attack'), box off
ylim([-50 100]), xlim(xlm);

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Asymmetry %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure
n=7;

% Body Pitch
k=7;
pert = -ga(:,:,k);
subplot(n,1,1)   
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Pitch'), box off
ylim([-50 100]), xlim(xlm);
clear pert

% Average Humeral Elevation Asymmetry
k=2;
pert = ga_asym(:,:,k);
subplot(n,1,2)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Elevation Asymmetry'), box off
ylim([-10 50]), xlim(xlm);
clear pert

% Average Retraction Asymmetry
k=3;
pert = ga_asym(:,:,k);
subplot(n,1,3)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Retraction Asymmetry'), box off
ylim([-10 50]), xlim(xlm);
clear pert

% Average Extension Asymmetry
k=1;
pert = ga_asym(:,:,k);
subplot(n,1,4)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Extension Asymmetry'), box off
ylim([-.10 .50]), xlim(xlm);
clear pert

% Average Elbow Angle Asymmetry
k=4;
pert = ga_asym(:,:,k);
y=[-10 70];
subplot(n,1,5)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
ylim(y)
title('Elbow Angle Asymmetry'), box off
ylim([-10 50]), xlim(xlm);
clear pert

% Average Hand Spread Angle Asymmetry
k=5;
pert = ga_asym(:,:,k);
subplot(n,1,6)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Hand Spread Angle Asymmetry'), box off
ylim([-10 80]), xlim(xlm);
clear pert

% Average Angle of Attack Asymmetry
k=6;
pert = ga_asym(:,:,k);
subplot(n,1,7)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Angle of Attack Asymmetry'), box off
ylim([-10 60]), xlim(xlm);
clear pert

%% 
save('Asymmetry_Analysis_BodyPerturbations')