%% Asymmetry Analysis

%% Create Grand Mean Control Data (Reference for Perturbation Trials)
clear all
close all

% Variables to load for each trial
% vars = {'nk','norm_domain','Std','asym','roll','rollV','pitch','pitchV','yaw','yawV'};
vars = {'Kinematics','nk','norm_domain','asym','r','rv','p','pv','y','yv','gust'};

% Load Variables for each control trial
PYc001 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/PYc001.mat',vars{:});
PYc003 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/PYc003.mat',vars{:});
RBc005 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/RBc005.mat',vars{:});
RBc006 = load ('/Users/davidboerma/Google Drive/Gust Response/Analysis/Control Trials/RBc006.mat',vars{:});

% nd = PYc001.norm_domain(:,1);

% Matrices for each kinematic variable (nk = norm_kinematics, i.e. kins normalized to wingbeats)
        % nk(:,1) = extNorm_L;
        % nk(:,2) = extNorm_R;
        % nk(:,3) = Roll;
        % nk(:,4) = elev_R;
        % nk(:,5) = prot_L;
        % nk(:,6) = prot_R;
        % nk(:,7) = elbL;
        % nk(:,8) = elbR;
        % nk(:,9) = dang3_radL;
        % nk(:,10) = dang3_radR;
        % nk(:,11) = r;
        % nk(:,12) = p;
        % nk(:,13) = y;
        % nk(:,14) = rv;
        % nk(:,15) = pv;
        % nk(:,16) = yv;
        % nk(:,17) = gust;
        % nk(:,18) = AoAL;
        % nk(:,19) = AoAr;
    
pshft = 50;        
    % Humeral Elevation & Depression
    l=3; r=4;
    elev = NaN(length(PYc003.nk)+50,8);
    elev(1:length(PYc001.nk),1) = PYc001.nk(:,l); % elev_L
    elev(1:length(PYc001.nk),2) = PYc001.nk(:,r); % elev_R
    elev(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % elev_L %PYc003 needs shifting .5 wingbeat to align with others
    elev(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % elev_R %PYc003 needs shifting .5 wingbeat to align with others
    elev(1:length(RBc005.nk),5) = RBc005.nk(:,l); % elev_L
    elev(1:length(RBc005.nk),6) = RBc005.nk(:,r); % elev_R
    elev(1:length(RBc006.nk),7) = RBc006.nk(:,l); % elev_L
    elev(1:length(RBc006.nk),8) = RBc006.nk(:,r); % elev_R
    elev(elev==0)=NaN;
    elev_refmean = nanmean(elev,2);
    elev_refsd   = nanstd(elev,0,2);
    
    % Humeral Protraction & Retraction
    l=5; r=6;
    prot = NaN(length(PYc003.nk)+50,8);
    prot(1:length(PYc001.nk),1) = PYc001.nk(:,l); % prot_L
    prot(1:length(PYc001.nk),2) = (PYc001.nk(:,r)); % prot_R
    prot(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % prot_L %PYc003 needs shifting .5 wingbeat to align with others
    prot(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % prot_R %PYc003 needs shifting .5 wingbeat to align with others
    prot(1:length(RBc005.nk),5) = RBc005.nk(:,l); % prot_L
    prot(1:length(RBc005.nk),6) = (RBc005.nk(:,r)); % prot_R
    prot(1:length(RBc006.nk),7) = RBc006.nk(:,l); % prot_L
    prot(1:length(RBc006.nk),8) = (RBc006.nk(:,r)); % prot_R
    prot_refmean = nanmean(prot,2);
    prot_refsd   = nanstd(prot,0,2);
    
    % Elbow Flexion & Extension
    l=7; r=8;
    elb = NaN(length(PYc003.nk)+50,8);
    elb(1:length(PYc001.nk),1) = PYc001.nk(:,l); % elb_L
    elb(1:length(PYc001.nk),2) = PYc001.nk(:,r); % elb_R
    elb(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % elb_L %PYc003 needs shifting .5 wingbeat to align with others
    elb(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % elb_R %PYc003 needs shifting .5 wingbeat to align with others
    elb(1:length(RBc005.nk),5) = RBc005.nk(:,l); % elb_L
    elb(1:length(RBc005.nk),6) = RBc005.nk(:,r); % elb_R
    elb(1:length(RBc006.nk),7) = RBc006.nk(:,l); % elb_L
    elb(1:length(RBc006.nk),8) = RBc006.nk(:,r); % elb_R
    elb_refmean = nanmean(elb,2);
    elb_refsd   = nanstd(elb,0,2);    
   
    % Wing Extension & Folding
    l=1; r=2;
    ext = NaN(length(PYc003.nk)+50,8);
    ext(1:length(PYc001.nk),1) = PYc001.nk(:,l); % ext_L
    ext(1:length(PYc001.nk),2) = PYc001.nk(:,r); % ext_R
    ext(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % ext_L %PYc003 needs shifting .5 wingbeat to align with others
    ext(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % ext_R %PYc003 needs shifting .5 wingbeat to align with others
    ext(1:length(RBc005.nk),5) = RBc005.nk(:,l); % ext_L
    ext(1:length(RBc005.nk),6) = RBc005.nk(:,r); % ext_R
    ext(1:length(RBc006.nk),7) = RBc006.nk(:,l); % ext_L
    ext(1:length(RBc006.nk),8) = RBc006.nk(:,r); % ext_R
    ext_refmean = nanmean(ext,2);
    ext_refsd   = nanstd(ext,0,2);    
   
    % Handwing Spreading
    l=9; r=10;
    hnd = NaN(length(PYc003.nk)+50,8);
    hnd(1:length(PYc001.nk),1) = PYc001.nk(:,l); % hnd_L
    hnd(1:length(PYc001.nk),2) = PYc001.nk(:,r); % hnd_R
    hnd(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % hnd_L %PYc003 needs shifting .5 wingbeat to align with others
    hnd(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % hnd_R %PYc003 needs shifting .5 wingbeat to align with others
    hnd(1:length(RBc005.nk),5) = RBc005.nk(:,l); % hnd_L
    hnd(1:length(RBc005.nk),6) = RBc005.nk(:,r); % hnd_R
    hnd(1:length(RBc006.nk),7) = RBc006.nk(:,l); % hnd_L
    hnd(1:length(RBc006.nk),8) = RBc006.nk(:,r); % hnd_R
    hnd_refmean = nanmean(hnd,2);
    hnd_refsd   = nanstd(hnd,0,2);
    
    % Angle of Attack
    l=18; r=19;
    aoa = NaN(length(PYc003.nk)+50,8);
    aoa(1:length(PYc001.nk),1) = PYc001.nk(:,l); % aoa_L
    aoa(1:length(PYc001.nk),2) = PYc001.nk(:,r); % aoa_R
    aoa(1:length(PYc003.nk(pshft:end,:)),3) = PYc003.nk(pshft:end,l); % aoa_L %PYc003 needs shifting .5 wingbeat to align with others
    aoa(1:length(PYc003.nk(pshft:end,:)),4) = PYc003.nk(pshft:end,r); % aoa_R %PYc003 needs shifting .5 wingbeat to align with others
    aoa(1:length(RBc005.nk),5) = RBc005.nk(:,l); % aoa_L
    aoa(1:length(RBc005.nk),6) = RBc005.nk(:,r); % aoa_R
    aoa(1:length(RBc006.nk),7) = RBc006.nk(:,l); % aoa_L
    aoa(1:length(RBc006.nk),8) = RBc006.nk(:,r); % aoa_R
    aoa_refmean = nanmean(aoa,2);
    aoa_refsd   = nanstd(aoa,0,2);
    
    % Body Roll
    roll = NaN(length(PYc003.nk)+50,4);
    roll(1:length(PYc001.nk),1) = PYc001.nk(:,11); % hnd_L
    roll(1:length(PYc003.nk(pshft:end,:)),2) = PYc003.nk(pshft:end,11); % hnd_L %PYc003 needs shifting .5 wingbeat to align with others
    roll(1:length(RBc005.nk),3) = RBc005.nk(:,11); % hnd_L
    roll(1:length(RBc006.nk),4) = RBc006.nk(:,11); % hnd_L
    roll_refmean = nanmean(roll,2);
    roll_refsd   = nanstd(roll,0,2);     
    
    % Body Pitch
    pitch = NaN(length(PYc003.nk)+50,4);
    pitch(1:length(PYc001.nk),1) = PYc001.nk(:,12); % hnd_L
    pitch(1:length(PYc003.nk(pshft:end,:)),2) = PYc003.nk(pshft:end,12); % hnd_L %PYc003 needs shifting .5 wingbeat to align with others
    pitch(1:length(RBc005.nk),3) = RBc005.nk(:,12); % hnd_L
    pitch(1:length(RBc006.nk),4) = RBc006.nk(:,12); % hnd_L
    pitch_refmean = nanmean(pitch,2);
    pitch_refsd   = nanstd(pitch,0,2);       
   
    %% Plot Single Kinematic Variables for pulling data for statistical analysis
% Produce plot?
pl = 'n';

% Which Variable?
v = elev;

% Create wingbeat-normalized time-vector
nd = [.25:.01:3.5]';

% Plot the Variable for each trial
if pl == 'y'
  lw = 3;  
  figure
  subplot(2,1,1)
  plot(nd, v, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
  subplot(2,1,2)
  plot(nd, elev, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
end

%% Plot Mean Unperturbed Kinematics
nd = [.25:.01:3.5]';

n = 7;
figure
subplot(n,1,1) %Roll
plot(nd, roll_refmean, 'r'), hold on
plot(nd, roll_refmean+roll_refsd,'--k')
plot(nd, roll_refmean-roll_refsd,'--k')
plot(nd, pitch_refmean, 'b'), hold on
plot(nd, pitch_refmean+pitch_refsd,'--k')
plot(nd, pitch_refmean-pitch_refsd,'--k')
title({'Unperturbed Trials';'Body Orientation'}),box off

subplot(n,1,2) %Humeral Elevation
plot(nd, elev_refmean), hold on
plot(nd, elev_refmean+elev_refsd,'--k')
plot(nd, elev_refmean-elev_refsd,'--k')
title('Humeral Elevation'),box off

subplot(n,1,3) %Humeral Protraction
plot(nd, prot_refmean), hold on
plot(nd, prot_refmean+prot_refsd,'--k')
plot(nd, prot_refmean-prot_refsd,'--k')
title('Humeral Protraction'),box off

subplot(n,1,4) %Wing Extension
plot(nd, ext_refmean), hold on
plot(nd, ext_refmean+ext_refsd,'--k')
plot(nd, ext_refmean-ext_refsd,'--k')
title('Wing Extension'),box off

subplot(n,1,5) %Elbow Angle
plot(nd, elb_refmean), hold on
plot(nd, elb_refmean+elb_refsd,'--k')
plot(nd, elb_refmean-elb_refsd,'--k')
title('Elbow Extension'),box off

subplot(n,1,6) %Handwing Abduction Angle
plot(nd, hnd_refmean), hold on
plot(nd, hnd_refmean+hnd_refsd,'--k')
plot(nd, hnd_refmean-hnd_refsd,'--k')
title('Handwing Abduction'), box off

subplot(n,1,7) %Angle of Attack
plot(nd, aoa_refmean), hold on
plot(nd, aoa_refmean+hnd_refsd,'--k')
plot(nd, aoa_refmean-hnd_refsd,'--k')
title('Angle of Attack'), box off

    %% Asymmetry measurement
    pshft = 50;
    
    % Ext_asym
    k=1;
    ext_asymref = NaN(length(PYc003.nk)+50,4);
    ext_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    ext_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    ext_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    ext_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    ext_asymrefmean = nanmean(ext_asymref,2);
    ext_asymrefsd   = nanstd(ext_asymref,0,2);  

    % Elev_asym
    k=2;
    elev_asymref = NaN(length(PYc003.nk)+50,4);
    elev_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    elev_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    elev_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    elev_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    elev_asymrefmean = nanmean(elev_asymref,2);
    elev_asymrefsd   = nanstd(elev_asymref,0,2);      
 
    % Prot_asym
    k=3;
    prot_asymref = NaN(length(PYc003.nk)+50,4);
    prot_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    prot_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    prot_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    prot_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    prot_asymrefmean = nanmean(prot_asymref,2);
    prot_asymrefsd   = nanstd(prot_asymref,0,2); 
    
    % Elb_asym
    k=4;
    elb_asymref = NaN(length(PYc003.nk)+50,4);
    elb_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    elb_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    elb_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    elb_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    elb_asymrefmean = nanmean(elb_asymref,2);
    elb_asymrefsd   = nanstd(elb_asymref,0,2);   
    
    % Hnd_asym
    k=5;
    hnd_asymref = NaN(length(PYc003.nk)+50,4);
    hnd_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    hnd_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    hnd_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    hnd_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    hnd_asymrefmean = nanmean(hnd_asymref,2);
    hnd_asymrefsd   = nanstd(hnd_asymref,0,2);
    
    % Aoa_asym
    k=6;
    aoa_asymref = NaN(length(PYc003.nk)+50,4);
    aoa_asymref(1:length(PYc001.asym),1) = PYc001.asym(:,k);  % ext_L
    aoa_asymref(1+pshft:length(PYc003.asym)+pshft,2) = PYc003.asym(:,k); % ext_L
    aoa_asymref(1:length(RBc005.asym),3) = RBc005.asym(:,k); % ext_L
    aoa_asymref(1:length(RBc006.asym),4) = RBc006.asym(:,k); % ext_L
    aoa_asymrefmean = nanmean(aoa_asymref,2);
    aoa_asymrefsd   = nanstd(aoa_asymref,0,2);
    
    
    % Concatenate mean/sd Reference Data
    % Mean Reference Data
        % refmean(:,1) = wing extension
        % refmean(:,2) = humeral elevation, i.e. elevation
        % refmean(:,3) = humeral protraction/retracion, i.e. sweep
        % refmean(:,4) = elbow angle
        % refmean(:,5) = handwing spread
        
        asymrefmean = NaN(length(ext_asymrefmean),6);
        asymrefmean(:,1) = ext_asymrefmean;
        asymrefmean(:,2) = elev_asymrefmean;
        asymrefmean(:,3) = prot_asymrefmean;
        asymrefmean(:,4) = elb_asymrefmean;
        asymrefmean(:,5) = hnd_asymrefmean;
        asymrefmean(:,6) = aoa_asymrefmean;
        
        
        asymrefsd = NaN(length(ext_asymrefsd),6);
        asymrefsd(:,1) = ext_asymrefsd;
        asymrefsd(:,2) = elev_asymrefsd;
        asymrefsd(:,3) = prot_asymrefsd;
        asymrefsd(:,4) = elb_asymrefsd;
        asymrefsd(:,5) = hnd_asymrefsd;
        asymrefsd(:,6) = aoa_asymrefsd;
        
%% Plot asym
k=6;
var = aoa_asymref;
figure, hold on
% shift=-.32; % shift control data along x-axis
plot(asymrefmean(:,k),'k','linewidth',3)
plot(asymrefmean(:,k)+asymrefsd(:,k),'--k')
plot(asymrefmean(:,k)-asymrefsd(:,k),'--k')
plot(var)
legend('RefMean','RefSD','RefSD','PYc001','PYc003','RBc005','RBc006')

%% Plot Single Kinematic Variables for pulling data for statistical analysis
% Produce plot?
pl = 'n';

% Which Variable?
v = pitch;

% Create wingbeat-normalized time-vector
nd = [.25:.01:3.5]';

% Plot the Variable for each trial
if pl == 'y'
  lw = 3;  
  figure
  subplot(2,1,1)
  plot(nd, v, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
  subplot(2,1,2)
  plot(nd, elev, 'linewidth',lw)
  legend('PYc001L','PYc001R','PYc003L','PYc003R','RBc005L','RBc005R','RBc006L','RBc006R')
end


%% Load Perturbed Data
RBg007 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/RBg007.mat',vars{:});
RBg017 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/RBg017.mat',vars{:});
PYg001 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/PYg001.mat',vars{:});
PYg002 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/PYg002.mat',vars{:});
PYg016 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/PYg016.mat',vars{:});
GGg008 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/GGg008.mat',vars{:});
GGg009 = load('/Users/davidboerma/Google Drive/Gust Response/Analysis/Wing Perturbations/GGg009.mat',vars{:});

numtrls = 7;
    % Humeral Elevation & Depression
    l=3; r=4;
    elev_pert = NaN(400,numtrls*2);
    elev_pert(1:length(RBg007.nk),1) = RBg007.nk(:,l); % elev_L
    elev_pert(1:length(RBg007.nk),2) = RBg007.nk(:,r); % elev_R
    elev_pert(1:length(PYg001.nk),3) = PYg001.nk(:,l); % elev_L
    elev_pert(1:length(PYg001.nk),4) = PYg001.nk(:,r); % elev_R
    elev_pert(1:length(PYg002.nk),5) = PYg002.nk(:,l); % elev_L
    elev_pert(1:length(PYg002.nk),6) = PYg002.nk(:,r); % elev_R
    elev_pert(1:length(PYg016.nk),7) = PYg016.nk(:,l); % elev_L
    elev_pert(1:length(PYg016.nk),8) = PYg016.nk(:,r); % elev_R
    elev_pert(1:length(GGg008.nk),9) = GGg008.nk(:,r); % elev_R
    elev_pert(1:length(GGg008.nk),10) = GGg008.nk(:,r); % elev_R
    elev_pert(1:length(GGg009.nk),11) = GGg009.nk(:,r); % elev_R
    elev_pert(1:length(GGg009.nk),12) = GGg009.nk(:,r); % elev_R
    elev_pert(1:length(RBg017.nk),13) = RBg017.nk(:,l); % elev_L
    elev_pert(1:length(RBg017.nk),14) = RBg017.nk(:,r); % elev_R
    elev_pert(elev_pert==0)=NaN;
    elev_pertmean = nanmean(elev_pert,2);
    elev_pertsd   = nanstd(elev_pert,0,2);
    
    % Humeral Protraction & Retraction
    l=5; r=6;
    prot_pert = NaN(400,numtrls*2);
    prot_pert(1:length(RBg007.nk),1) = RBg007.nk(:,l); % elev_L
    prot_pert(1:length(RBg007.nk),2) = RBg007.nk(:,r); % elev_R
    prot_pert(1:length(PYg001.nk),3) = PYg001.nk(:,l); % elev_L
    prot_pert(1:length(PYg001.nk),4) = PYg001.nk(:,r); % elev_R
    prot_pert(1:length(PYg002.nk),5) = PYg002.nk(:,l); % elev_L
    prot_pert(1:length(PYg002.nk),6) = PYg002.nk(:,r); % elev_R
    prot_pert(1:length(PYg016.nk),7) = PYg016.nk(:,l); % elev_L
    prot_pert(1:length(PYg016.nk),8) = PYg016.nk(:,r); % elev_R
    prot_pert(1:length(GGg008.nk),9) = GGg008.nk(:,r); % elev_R
    prot_pert(1:length(GGg008.nk),10) = GGg008.nk(:,r); % elev_R
    prot_pert(1:length(GGg009.nk),11) = GGg009.nk(:,r); % elev_R
    prot_pert(1:length(GGg009.nk),12) = GGg009.nk(:,r); % elev_R
    prot_pert(1:length(RBg017.nk),13) = RBg017.nk(:,l); % elev_L
    prot_pert(1:length(RBg017.nk),14) = RBg017.nk(:,r); % elev_R
    prot_pert(prot_pert==0)=NaN;
    prot_pertmean = nanmean(prot_pert,2);
    prot_pertsd   = nanstd(prot_pert,0,2);
    
    % Elbow Flexion & Extension
    l=7; r=8;
    elb_pert = NaN(400,numtrls*2);
    elb_pert(1:length(RBg007.nk),1) = RBg007.nk(:,l); % elev_L
    elb_pert(1:length(RBg007.nk),2) = RBg007.nk(:,r); % elev_R
    elb_pert(1:length(PYg001.nk),3) = PYg001.nk(:,l); % elev_L
    elb_pert(1:length(PYg001.nk),4) = PYg001.nk(:,r); % elev_R
    elb_pert(1:length(PYg002.nk),5) = PYg002.nk(:,l); % elev_L
    elb_pert(1:length(PYg002.nk),6) = PYg002.nk(:,r); % elev_R
    elb_pert(1:length(PYg016.nk),7) = PYg016.nk(:,l); % elev_L
    elb_pert(1:length(PYg016.nk),8) = PYg016.nk(:,r); % elev_R
    elb_pert(1:length(GGg008.nk),9) = GGg008.nk(:,r); % elev_R
    elb_pert(1:length(GGg008.nk),10) = GGg008.nk(:,r); % elev_R
    elb_pert(1:length(GGg009.nk),11) = GGg009.nk(:,r); % elev_R
    elb_pert(1:length(GGg009.nk),12) = GGg009.nk(:,r); % elev_R
    elb_pert(1:length(RBg017.nk),13) = RBg017.nk(:,l); % elev_L
    elb_pert(1:length(RBg017.nk),14) = RBg017.nk(:,r); % elev_R
    elb_pert(elb_pert==0)=NaN;
    elb_pertmean = nanmean(elb_pert,2);
    elb_pertsd   = nanstd(elb_pert,0,2);  
   
    % Wing Extension & Folding
    l=1; r=2;
    ext_pert = NaN(400,numtrls*2);
    ext_pert(1:length(RBg007.nk),1) = RBg007.nk(:,l); % elev_L
    ext_pert(1:length(RBg007.nk),2) = RBg007.nk(:,r); % elev_R
    ext_pert(1:length(PYg001.nk),3) = PYg001.nk(:,l); % elev_L
    ext_pert(1:length(PYg001.nk),4) = PYg001.nk(:,r); % elev_R
    ext_pert(1:length(PYg002.nk),5) = PYg002.nk(:,l); % elev_L
    ext_pert(1:length(PYg002.nk),6) = PYg002.nk(:,r); % elev_R
    ext_pert(1:length(PYg016.nk),7) = PYg016.nk(:,l); % elev_L
    ext_pert(1:length(PYg016.nk),8) = PYg016.nk(:,r); % elev_R
    ext_pert(1:length(GGg008.nk),9) = GGg008.nk(:,r); % elev_R
    ext_pert(1:length(GGg008.nk),10) = GGg008.nk(:,r); % elev_R
    ext_pert(1:length(GGg009.nk),11) = GGg009.nk(:,r); % elev_R
    ext_pert(1:length(GGg009.nk),12) = GGg009.nk(:,r); % elev_R
    ext_pert(1:length(RBg017.nk),13) = RBg017.nk(:,l); % elev_L
    ext_pert(1:length(RBg017.nk),14) = RBg017.nk(:,r); % elev_R
    ext_pert(ext_pert==0)=NaN;
    ext_pertmean = nanmean(ext_pert,2);
    ext_pertsd   = nanstd(ext_pert,0,2);    
   
    % Handwing Spreading
    l=9; r=10;
    hnd_pert = NaN(400,numtrls*2);
    hnd_pert(1:length(RBg007.nk),1) = RBg007.nk(:,l); % elev_L
    hnd_pert(1:length(RBg007.nk),2) = RBg007.nk(:,r); % elev_R
    hnd_pert(1:length(PYg001.nk),3) = PYg001.nk(:,l); % elev_L
    hnd_pert(1:length(PYg001.nk),4) = PYg001.nk(:,r); % elev_R
    hnd_pert(1:length(PYg002.nk),5) = PYg002.nk(:,l); % elev_L
    hnd_pert(1:length(PYg002.nk),6) = PYg002.nk(:,r); % elev_R
    hnd_pert(1:length(PYg016.nk),7) = PYg016.nk(:,l); % elev_L
    hnd_pert(1:length(PYg016.nk),8) = PYg016.nk(:,r); % elev_R
    hnd_pert(1:length(GGg008.nk),9) = GGg008.nk(:,r); % elev_R
    hnd_pert(1:length(GGg008.nk),10) = GGg008.nk(:,r); % elev_R
    hnd_pert(1:length(GGg009.nk),11) = GGg009.nk(:,r); % elev_R
    hnd_pert(1:length(GGg009.nk),12) = GGg009.nk(:,r); % elev_R
    hnd_pert(1:length(RBg017.nk),13) = RBg017.nk(:,l); % elev_L
    hnd_pert(1:length(RBg017.nk),14) = RBg017.nk(:,r); % elev_R
    hnd_pert(hnd_pert==0)=NaN;
    hnd_pertmean = nanmean(hnd_pert,2);
    hnd_pertsd   = nanstd(hnd_pert,0,2);    
    
    % Angle of Attack
    l=18; r=19;
    aoa_pert = NaN(400,numtrls*2);
    aoa_pert(1:length(RBg007.nk),1) = RBg007.nk(:,l); % elev_L
    aoa_pert(1:length(RBg007.nk),2) = RBg007.nk(:,r); % elev_R
    aoa_pert(1:length(PYg001.nk),3) = PYg001.nk(:,l); % elev_L
    aoa_pert(1:length(PYg001.nk),4) = PYg001.nk(:,r); % elev_R
    aoa_pert(1:length(PYg002.nk),5) = PYg002.nk(:,l); % elev_L
    aoa_pert(1:length(PYg002.nk),6) = PYg002.nk(:,r); % elev_R
    aoa_pert(1:length(PYg016.nk),7) = PYg016.nk(:,l); % elev_L
    aoa_pert(1:length(PYg016.nk),8) = PYg016.nk(:,r); % elev_R
    aoa_pert(1:length(GGg008.nk),9) = GGg008.nk(:,r); % elev_R
    aoa_pert(1:length(GGg008.nk),10) = GGg008.nk(:,r); % elev_R
    aoa_pert(1:length(GGg009.nk),11) = GGg009.nk(:,r); % elev_R
    aoa_pert(1:length(GGg009.nk),12) = GGg009.nk(:,r); % elev_R
    aoa_pert(1:length(RBg017.nk),13) = RBg017.nk(:,l); % elev_L
    aoa_pert(1:length(RBg017.nk),14) = RBg017.nk(:,r); % elev_R
    aoa_pert(aoa_pert==0)=NaN;
    aoa_pertmean = nanmean(aoa_pert,2);
    aoa_pertsd   = nanstd(aoa_pert,0,2);  
   
    % Body Roll
    k=11;
    roll_pert = NaN(400,numtrls);
    roll_pert(1:length(RBg007.nk),1) = RBg007.nk(:,k); % elev_L
    roll_pert(1:length(PYg001.nk),2) = PYg001.nk(:,k); % elev_L
    roll_pert(1:length(PYg002.nk),3) = PYg002.nk(:,k); % elev_L
    roll_pert(1:length(PYg016.nk),4) = PYg016.nk(:,k); % elev_L
    roll_pert(1:length(GGg008.nk),5) = GGg008.nk(:,k); % elev_R
    roll_pert(1:length(GGg009.nk),6) = GGg009.nk(:,k); % elev_R
    roll_pert(1:length(RBg017.nk),7) = RBg017.nk(:,k); % elev_L
    roll_pert(roll_pert==0)=NaN;
    roll_pertmean = nanmean(roll_pert,2);
    roll_pertsd   = nanstd(roll_pert,0,2);       
   

%% Plot Humeral Elevation and Gust timing for each trial

l = 3;
r = 4;

plt='n';
if plt=='y'
    figure,hold on
    % plot(zz(:,1),'b'),hold on
    % plot(zz(:,2),'r')
    % plot(shift/3+1:length(RBg007.nk)+shift/3,RBg007.nk(:,17))
    % title('RBg007') 
    plot(RBg007.nk(:,l),'b') 
    plot(RBg007.nk(:,r),'r')
    plot(RBg007.nk(:,17))
    title('RBg007')


    figure,hold on
    % plot(zz(:,3),'b'),hold on
    % plot(zz(:,4),'r')
    % plot(shift/3+1:length(PYg001.nk)+shift/3,PYg001.nk(:,17))
    plot(PYg001.nk(:,l),'b')
    plot(PYg001.nk(:,r),'r')
    plot(PYg001.nk(:,17))
    title('PYg001')

    figure,hold on
    % plot(zz(:,5),'b'),hold on
    % plot(zz(:,6),'r')
    % plot(shift+1:length(PYg002.nk)+shift,PYg002.nk(:,17))
    plot(PYg002.nk(:,l),'b')
    plot(PYg002.nk(:,r),'r')
    plot(PYg002.nk(:,17))
    title('PYg002')

    figure,hold on
    % plot(zz(:,7),'b'),hold on
    % plot(zz(:,8),'r')
    % plot(shift+1:length(PYg016.nk)+shift,PYg016.nk(:,17))
    plot(PYg016.nk(:,l),'b')
    plot(PYg016.nk(:,r),'r')
    plot(PYg016.nk(:,17))
    title('PYg016')

    figure,hold on
    % plot(zz(:,9),'b'),hold on
    % plot(zz(:,10),'r')
    % plot(shift+1:length(GGg008.nk)+shift,GGg008.nk(:,17))
    plot(GGg008.nk(:,l),'b')
    plot(GGg008.nk(:,r),'r')
    plot(GGg008.nk(:,17))
    title('GGg008')

    figure,hold on
    % plot(zz(:,11),'b'),hold on
    % plot(zz(:,12),'r')
    % plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
    plot(GGg009.nk(:,l),'b')
    plot(GGg009.nk(:,r),'r')
    plot(GGg009.nk(:,17))
    title('GGg009')

    figure,hold on
    % plot(zz(:,11),'b'),hold on
    % plot(zz(:,12),'r')
    % plot(shift+1:length(GGg008.nk)+shift,GGg009.nk(:,17))
    plot(RBg017.nk(:,l),'b')
    plot(RBg017.nk(:,r),'r')
    plot(RBg017.nk(:,17))
    title('RBg017')
end

%% Shift Data so that 1st top-of-US after gust is at x=100
% Shift is from data contained in each trial's .nk matrix
shft = [25    %RBg007
        25    %PYg001
        75    %PYg002
        75    %PYg016
        75    %GGg008
        75    %GGg009
        25];  %RBg017
    
%     Which wing is perturbed?
%         RBg007: L
%         PYg001: L
%         PYg002: L
%         PYg016: R
%         GGg008: R
%         GGg009: R
%         RBg017: L

% Gust-aligned kinematic data 
ga = NaN(400,numtrls*2,numtrls);

% Wing Extension
l = 1; % kinematic data for left wing
r = 2; % kinematic data for right wing
j=1;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1:2,j) = RBg007.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),3:4,j) = PYg001.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),5:6,j) = PYg002.nk(:,l:r); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),7:8,j) = PYg016.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),9:10,j) = GGg008.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),11:12,j) = GGg009.nk(:,l:r); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),13:14,j) = RBg017.nk(:,l:r); clear k
%   Perturbed Wing Kinematics
    wng_pert_ext = NaN(400,numtrls,2);
    q=1;
    wng_pert_ext(:,1,q) = ga(:,1,j); % RBg007
    wng_pert_ext(:,2,q) = ga(:,3,j); % PYg001
    wng_pert_ext(:,3,q) = ga(:,5,j); % PYg002
    wng_pert_ext(:,4,q) = ga(:,8,j); % PYg016
    wng_pert_ext(:,5,q) = ga(:,10,j); % GGg008
    wng_pert_ext(:,6,q) = ga(:,12,j); % GGg009
    wng_pert_ext(:,7,q) = ga(:,13,j); % RBg017
%   Unperturbed Wing Kinematics
    q=2;
    wng_pert_ext(:,1,q) = ga(:,2,j); % RBg007
    wng_pert_ext(:,2,q) = ga(:,4,j); % PYg001
    wng_pert_ext(:,3,q) = ga(:,6,j); % PYg002
    wng_pert_ext(:,4,q) = ga(:,7,j); % PYg016
    wng_pert_ext(:,5,q) = ga(:,9,j); % GGg008
    wng_pert_ext(:,6,q) = ga(:,11,j); % GGg009
    wng_pert_ext(:,7,q) = ga(:,14,j); % RBg017



% Humeral Elevation
l = 3; % kinematic data for left wing
r = 4; % kinematic data for right wing
j=2;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1:2,j) = RBg007.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),3:4,j) = PYg001.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),5:6,j) = PYg002.nk(:,l:r); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),7:8,j) = PYg016.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),9:10,j) = GGg008.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),11:12,j) = GGg009.nk(:,l:r); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),13:14,j) = RBg017.nk(:,l:r); clear k

%   Perturbed Wing Kinematics
    wng_pert_elev = NaN(400,6,2);
    q=1;
    wng_pert_elev(:,1,q) = ga(:,1,j); % RBg007
    wng_pert_elev(:,2,q) = ga(:,3,j); % PYg001
    wng_pert_elev(:,3,q) = ga(:,5,j); % PYg002
    wng_pert_elev(:,4,q) = ga(:,8,j); % PYg016
    wng_pert_elev(:,5,q) = ga(:,10,j); % GGg008
    wng_pert_elev(:,6,q) = ga(:,12,j); % GGg009
    wng_pert_elev(:,7,q) = ga(:,13,j); % RBg017
%   Unperturbed Wing Kinematics
    q=2;
    wng_pert_elev(:,1,q) = ga(:,2,j); % RBg007
    wng_pert_elev(:,2,q) = ga(:,4,j); % PYg001
    wng_pert_elev(:,3,q) = ga(:,6,j); % PYg002
    wng_pert_elev(:,4,q) = ga(:,7,j); % PYg016
    wng_pert_elev(:,5,q) = ga(:,9,j); % GGg008
    wng_pert_elev(:,6,q) = ga(:,11,j); % GGg009
    wng_pert_elev(:,7,q) = ga(:,14,j); % RBg017


% Humeral Protraction
l = 5; % kinematic data for left wing
r = 6; % kinematic data for right wing
j=3;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1:2,j) = RBg007.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),3:4,j) = PYg001.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),5:6,j) = PYg002.nk(:,l:r); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),7:8,j) = PYg016.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),9:10,j) = GGg008.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),11:12,j) = GGg009.nk(:,l:r); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),13:14,j) = RBg017.nk(:,l:r); clear k

%   Perturbed Wing Kinematics
    wng_pert_prot = NaN(400,6,2);
    q=1;
    wng_pert_prot(:,1,q) = ga(:,1,j); % RBg007
    wng_pert_prot(:,2,q) = ga(:,3,j); % PYg001
    wng_pert_prot(:,3,q) = ga(:,5,j); % PYg002
    wng_pert_prot(:,4,q) = ga(:,8,j); % PYg016
    wng_pert_prot(:,5,q) = ga(:,10,j); % GGg008
    wng_pert_prot(:,6,q) = ga(:,12,j); % GGg009
    wng_pert_prot(:,7,q) = ga(:,13,j); % RBg017
%   Unperturbed Wing Kinematics
    q=2;
    wng_pert_prot(:,1,q) = ga(:,2,j); % RBg007
    wng_pert_prot(:,2,q) = ga(:,4,j); % PYg001
    wng_pert_prot(:,3,q) = ga(:,6,j); % PYg002
    wng_pert_prot(:,4,q) = ga(:,7,j); % PYg016
    wng_pert_prot(:,5,q) = ga(:,9,j); % GGg008
    wng_pert_prot(:,6,q) = ga(:,11,j); % GGg009
    wng_pert_prot(:,7,q) = ga(:,14,j); % RBg017

% Elbow Angle
l = 7; % kinematic data for left wing
r = 8; % kinematic data for right wing
j=4;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1:2,j) = RBg007.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),3:4,j) = PYg001.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),5:6,j) = PYg002.nk(:,l:r); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),7:8,j) = PYg016.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),9:10,j) = GGg008.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),11:12,j) = GGg009.nk(:,l:r); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),13:14,j) = RBg017.nk(:,l:r); clear k

%   Perturbed Wing Kinematics
    wng_pert_elb = NaN(400,6,2);
    q=1;
    wng_pert_elb(:,1,q) = ga(:,1,j); % RBg007
    wng_pert_elb(:,2,q) = ga(:,3,j); % PYg001
    wng_pert_elb(:,3,q) = ga(:,5,j); % PYg002
    wng_pert_elb(:,4,q) = ga(:,8,j); % PYg016
    wng_pert_elb(:,5,q) = ga(:,10,j); % GGg008
    wng_pert_elb(:,6,q) = ga(:,12,j); % GGg009
    wng_pert_elb(:,7,q) = ga(:,13,j); % RBg017
%   Unperturbed Wing Kinematics
    q=2;
    wng_pert_elb(:,1,q) = ga(:,2,j); % RBg007
    wng_pert_elb(:,2,q) = ga(:,4,j); % PYg001
    wng_pert_elb(:,3,q) = ga(:,6,j); % PYg002
    wng_pert_elb(:,4,q) = ga(:,7,j); % PYg016
    wng_pert_elb(:,5,q) = ga(:,9,j); % GGg008
    wng_pert_elb(:,6,q) = ga(:,11,j); % GGg009
    wng_pert_elb(:,7,q) = ga(:,14,j); % RBg017

% hand Spread
l = 9; % kinematic data for left wing
r = 10; % kinematic data for right wing
j=5;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1:2,j) = RBg007.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),3:4,j) = PYg001.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),5:6,j) = PYg002.nk(:,l:r); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),7:8,j) = PYg016.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),9:10,j) = GGg008.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),11:12,j) = GGg009.nk(:,l:r); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),13:14,j) = RBg017.nk(:,l:r); clear k

%   Perturbed Wing Kinematics
    wng_pert_hnd = NaN(400,6,2);
    q=1;
    wng_pert_hnd(:,1,q) = ga(:,1,j); % RBg007
    wng_pert_hnd(:,2,q) = ga(:,3,j); % PYg001
    wng_pert_hnd(:,3,q) = ga(:,5,j); % PYg002
    wng_pert_hnd(:,4,q) = ga(:,8,j); % PYg016
    wng_pert_hnd(:,5,q) = ga(:,10,j); % GGg008
    wng_pert_hnd(:,6,q) = ga(:,12,j); % GGg009
    wng_pert_hnd(:,7,q) = ga(:,13,j); % RBg017
%   Unperturbed Wing Kinematics
    q=2;
    wng_pert_hnd(:,1,q) = ga(:,2,j); % RBg007
    wng_pert_hnd(:,2,q) = ga(:,4,j); % PYg001
    wng_pert_hnd(:,3,q) = ga(:,6,j); % PYg002
    wng_pert_hnd(:,4,q) = ga(:,7,j); % PYg016
    wng_pert_hnd(:,5,q) = ga(:,9,j); % GGg008
    wng_pert_hnd(:,6,q) = ga(:,11,j); % GGg009
    wng_pert_hnd(:,7,q) = ga(:,14,j); % RBg017

% angle of attack
l = 18; % kinematic data for left wing
r = 19; % kinematic data for right wing
j=6;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1:2,j) = RBg007.nk(:,l:r); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),3:4,j) = PYg001.nk(:,l:r); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),5:6,j) = PYg002.nk(:,l:r); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),7:8,j) = PYg016.nk(:,l:r); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),9:10,j) = GGg008.nk(:,l:r); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),11:12,j) = GGg009.nk(:,l:r); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),13:14,j) = RBg017.nk(:,l:r); clear k

%   Perturbed Wing Kinematics
    wng_pert_aoa = NaN(400,6,2);
    q=1;
    wng_pert_aoa(:,1,q) = ga(:,1,j); % RBg007
    wng_pert_aoa(:,2,q) = ga(:,3,j); % PYg001
    wng_pert_aoa(:,3,q) = ga(:,5,j); % PYg002
    wng_pert_aoa(:,4,q) = ga(:,8,j); % PYg016
    wng_pert_aoa(:,5,q) = ga(:,10,j); % GGg008
    wng_pert_aoa(:,6,q) = ga(:,12,j); % GGg009
    wng_pert_aoa(:,7,q) = ga(:,13,j); % RBg017
%   Unperturbed Wing Kinematics
    q=2;
    wng_pert_aoa(:,1,q) = ga(:,2,j); % RBg007
    wng_pert_aoa(:,2,q) = ga(:,4,j); % PYg001
    wng_pert_aoa(:,3,q) = ga(:,6,j); % PYg002
    wng_pert_aoa(:,4,q) = ga(:,7,j); % PYg016
    wng_pert_aoa(:,5,q) = ga(:,9,j); % GGg008
    wng_pert_aoa(:,6,q) = ga(:,11,j); % GGg009
    wng_pert_aoa(:,7,q) = ga(:,14,j); % RBg017
    
% roll (all positive)
j=7;
p=11;
k=1; ga(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = -RBg007.nk(:,p); clear k
k=2; ga(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = -PYg001.nk(:,p); clear k
k=3; ga(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = -PYg002.nk(:,p); clear k
k=4; ga(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.nk(:,p); clear k
k=5; ga(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.nk(:,p); clear k
k=6; ga(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.nk(:,p); clear k
k=7; ga(shft(k)+1:length(RBg017.nk)+shft(k),7,j) = -RBg017.nk(:,p); clear k

plt='n';
if plt=='y'
    % Plot Humeral elevation/depression to check that up/downstrokes align between perturbed and reference data
    figure
    hold on
    plot(nd+.5,elev_refmean,'k','linewidth',3)
    plot(nd+.5,elev_refmean+elev_refsd,'--k')
    plot(nd+.5,elev_refmean-elev_refsd,'--k')
    plot(0:.01:(.01*length(ga)-.01),ga(:,:,2))
    title('Humeral Elevation')
    legend('Ref Mean','RefSD','RefSD','RBg007L','RBg007R','PYg001L','PYg001R','PYg002L','PYg002R','PYg016L','PYg016R','GGg008L','GGg008R','GGg009L','GGg009R','RBg017L','RBg017R')

    % Plot Humeral Protraction to check
    figure
    hold on
    plot(nd+.5,prot_refmean,'k','linewidth',3)
    plot(nd+.5,prot_refmean+prot_refsd,'--k')
    plot(nd+.5,prot_refmean-prot_refsd,'--k')
    plot(0:.01:(.01*length(ga)-.01),ga(:,:,3))
    title('Humeral Protraction')
    legend('Ref Mean','RefSD','RefSD','RBg007L','RBg007R','PYg001L','PYg001R','PYg002L','PYg002R','PYg016L','PYg016R','GGg008L','GGg008R','GGg009L','GGg009R','RBg017L','RBg017R')

    % Plot Roll
    figure
    hold on
    plot(nd+.5,roll_refmean,'k','linewidth',3)
    plot(nd+.5,roll_refmean+roll_refsd,'--k')
    plot(nd+.5,roll_refmean-roll_refsd,'--k')
    plot(0:.01:(.01*length(ga)-.01),ga(:,:,7))
    title('Body Roll')
    legend('Ref Mean','RefSD','RefSD','RBg007','PYg001','PYg002','PYg016','GGg008','GGg009','RBg017')
end

%% Plot mean kinemtics against Control kinematics
%  For perturbed trials, average by perturbed wing and unperturbed wing
figure
n=7; % number of plots in subplot
shift=0.5; % shift control data along x-axis
xlm = [0 3];
% Body Roll
k=7;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = roll_refmean;
refsd = roll_refsd;
subplot(n,1,1)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Roll'), box off
xlim(xlm)

% Humeral Elevation
x =           wng_pert_elev;
pert_mean =   nanmean(x(:,:,1),2);
pert_sd =     nanstd(x(:,:,1),0,2);
unpert_mean = nanmean(x(:,:,2),2);
unpert_sd =   nanstd(x(:,:,2),0,2);
refmean =     elev_refmean;
refsd =       elev_refsd;
subplot(n,1,2)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'r','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--r')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--r')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean+unpert_sd,'--k')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean-unpert_sd,'--k')
title('Average Humeral Elevation'), box off
xlim(xlm),ylim([-75 75])

% Humeral Retraction
x =           wng_pert_prot;
pert_mean =   nanmean(x(:,:,1),2);
pert_sd =     nanstd(x(:,:,1),0,2);
unpert_mean = nanmean(x(:,:,2),2);
unpert_sd =   nanstd(x(:,:,2),0,2);
refmean =     prot_refmean;
refsd =       prot_refsd;
subplot(n,1,3)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'r','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--r')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--r')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean+unpert_sd,'--k')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean-unpert_sd,'--k')
title('Average Humeral Retraction'), box off
xlim(xlm),ylim([50 200])

% Wing Extension
x =           wng_pert_ext;
pert_mean =   nanmean(x(:,:,1),2);
pert_sd =     nanstd(x(:,:,1),0,2);
unpert_mean = nanmean(x(:,:,2),2);
unpert_sd =   nanstd(x(:,:,2),0,2);
refmean =     ext_refmean;
refsd =       ext_refsd;
subplot(n,1,4)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'r','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--r')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--r')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean+unpert_sd,'--k')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean-unpert_sd,'--k')
title('Average Wing Extension'), box off
xlim(xlm),ylim([.3 1.2])

% Elbow Extension
x =           wng_pert_elb;
pert_mean =   nanmean(x(:,:,1),2);
pert_sd =     nanstd(x(:,:,1),0,2);
unpert_mean = nanmean(x(:,:,2),2);
unpert_sd =   nanstd(x(:,:,2),0,2);
refmean =     elb_refmean;
refsd =       elb_refsd;
subplot(n,1,5)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'r','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--r')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--r')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean+unpert_sd,'--k')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean-unpert_sd,'--k')
title('Average Elbow Extension'), box off
xlim(xlm),ylim([0 150])

% Handwing Abduction
x =           wng_pert_hnd;
pert_mean =   nanmean(x(:,:,1),2);
pert_sd =     nanstd(x(:,:,1),0,2);
unpert_mean = nanmean(x(:,:,2),2);
unpert_sd =   nanstd(x(:,:,2),0,2);
refmean =     hnd_refmean;
refsd =       hnd_refsd;
subplot(n,1,6)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'r','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--r')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--r')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean+unpert_sd,'--k')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean-unpert_sd,'--k')
title('Average Handwing Abduction'), box off
xlim(xlm),ylim([50 175])

% Angle of Attack
x =           wng_pert_aoa;
pert_mean =   nanmean(x(:,:,1),2);
pert_sd =     nanstd(x(:,:,1),0,2);
unpert_mean = nanmean(x(:,:,2),2);
unpert_sd =   nanstd(x(:,:,2),0,2);
refmean =     aoa_refmean;
refsd =       aoa_refsd;
subplot(n,1,7)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'r','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--r')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--r')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean+unpert_sd,'--k')
plot(0:.01:(.01*length(unpert_mean)-.01),unpert_mean-unpert_sd,'--k')
title('Average Angle of Attack'), box off
xlim(xlm),ylim([-50 100])



%% Plot other variables for checking:
j = 6;
refmean = aoa_refmean;
refsd  = aoa_refsd;
figure
hold on
plot(nd+.5,refmean,'k','linewidth',3)
plot(nd+.5,refmean+refsd,'--k')
plot(nd+.5,refmean-refsd,'--k')
plot(0:.01:(.01*length(ga)-.01),ga(:,:,j))
legend('RefMean','RefSD','RefSD','pyg06L','pyg06R','pyg17L','pyg17R','rbg11L','rbg11R','rbg12L','rbg12R','ggg02L','ggg02R','ggg21L','ggg21R','ggg07L','ggg07R','bgg04L','bgg04R')

%% Gust-aligned asymmetry data
ga_asym = NaN(400,12,5);

% extension asymmetry data
j=1;
p=1;
k=1; ga_asym(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = RBg007.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = PYg001.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = PYg002.asym(:,p); clear k
k=4; ga_asym(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.asym(:,p); clear k

% humeral elevation asymmetry data
j=2;
p=2;
k=1; ga_asym(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = RBg007.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = PYg001.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = PYg002.asym(:,p); clear k
k=4; ga_asym(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.asym(:,p); clear k

% humeral sweep asymmetry data
j=3;
p=3;
k=1; ga_asym(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = RBg007.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = PYg001.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = PYg002.asym(:,p); clear k
k=4; ga_asym(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.asym(:,p); clear k

% Elbow angle asymmetry data
j=4;
p=4;
k=1; ga_asym(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = RBg007.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = PYg001.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = PYg002.asym(:,p); clear k
k=4; ga_asym(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.asym(:,p); clear k

% handwing spread asymmetry data
j=5;
p=5;
k=1; ga_asym(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = RBg007.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = PYg001.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = PYg002.asym(:,p); clear k
k=4; ga_asym(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.asym(:,p); clear k

% angle of attack asymmetry data
j=6;
p=6;
k=1; ga_asym(shft(k)+1:length(RBg007.nk)+shft(k),1,j) = RBg007.asym(:,p); clear k
k=2; ga_asym(shft(k)+1:length(PYg001.nk)+shft(k),2,j) = PYg001.asym(:,p); clear k
k=3; ga_asym(shft(k)+1:length(PYg002.nk)+shft(k),3,j) = PYg002.asym(:,p); clear k
k=4; ga_asym(shft(k)+1:length(PYg016.nk)+shft(k),4,j) = PYg016.asym(:,p); clear k
k=5; ga_asym(shft(k)+1:length(GGg008.nk)+shft(k),5,j) = GGg008.asym(:,p); clear k
k=6; ga_asym(shft(k)+1:length(GGg009.nk)+shft(k),6,j) = GGg009.asym(:,p); clear k


ga_asym(ga_asym==0)=NaN;


%% Calculate average asymmetries across trials
% Multiplot: change k to change plotted kinematic variable
plt = 'n';
if plt=='y';
    figure, hold on
    k=6;
    shift=0.5; % shift control data along x-axis
    plot(nd+shift,asymrefmean(:,k),'k','linewidth',3)
    plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
    plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')
    plot(0:.01:(.01*length(ga_asym)-.01),ga_asym(:,:,k))
    legend('RefMean','RefSD','RefSD','pyg06','pyg17','rbg11','rbg12','ggg02','ggg21','ggg07','bgg04')

    % Average Humeral Elevation Asymmetry
    k=2;
    avg_elev = nanmean(ga_asym(:,:,k),2);
    avg_elev_sd = nanstd(ga_asym(:,:,k),0,2);
    y=[-10 50];
    figure
    plot(nd+shift,asymrefmean(:,k),'k','linewidth',3), hold on
    plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
    plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')    
    plot(0:.01:(.01*length(avg_elev)-.01),avg_elev,'r','linewidth',3)
    plot(0:.01:(.01*length(avg_elev)-.01),avg_elev+avg_elev_sd,'--r')
    plot(0:.01:(.01*length(avg_elev)-.01),avg_elev-avg_elev_sd,'--r')
    title('Average Elevation Asymmetry'), box off
    ylim(y), xlim(xlm);

    % Average Extension Asymmetry
    k=1;
    avg_ext = nanmean(ga_asym(:,:,k),2);
    avg_ext_sd = nanstd(ga_asym(:,:,k),0,2);
    y=[-.1 .4];
    figure
    plot(nd+shift,asymrefmean(:,k),'k','linewidth',3), hold on
    plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
    plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')    
    plot(0:.01:(.01*length(avg_ext)-.01),avg_ext,'r','linewidth',3)
    plot(0:.01:(.01*length(avg_ext)-.01),avg_ext+avg_ext_sd,'--r')
    plot(0:.01:(.01*length(avg_ext)-.01),avg_ext-avg_ext_sd,'--r')
    ylim(y), xlim(xlm);
    title('Average extension Asymmetry'), box off


    % Average Elbow Angle Asymmetry
    k=4;
    avg_elb = nanmean(ga_asym(:,:,k),2);
    avg_elb_sd = nanstd(ga_asym(:,:,k),0,2);

    figure
    plot(nd+shift,asymrefmean(:,k),'k','linewidth',3), hold on
    plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
    plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')    
    plot(0:.01:(.01*length(avg_elb)-.01),avg_elb,'r','linewidth',3)
    plot(0:.01:(.01*length(avg_elb)-.01),avg_elb+avg_elb_sd,'--r')
    plot(0:.01:(.01*length(avg_elb)-.01),avg_elb-avg_elb_sd,'--r')
    title('Average Elbow Angle Asymmetry'), box off


    % Average Hand Spread Angle Asymmetry
    k=5;
    avg_hnd = nanmean(ga_asym(:,:,k),2);
    avg_hnd_sd = nanstd(ga_asym(:,:,k),0,2);
    y=[-20 80];
    figure
    plot(nd+shift,asymrefmean(:,k),'k','linewidth',3), hold on
    plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
    plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')    
    plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd,'r','linewidth',3) 
    plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd+avg_hnd_sd,'--r')
    plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd-avg_hnd_sd,'--r')
    ylim(y)
    title('Average Hand Spread Angle Asymmetry'), box off

    % Average Angle of Attack Asymmetry
    k=6;
    avg_aoa = nanmean(ga_asym(:,:,k),2);
    avg_aoa_sd = nanstd(ga_asym(:,:,k),0,2);
    y=[-10 60];
    figure
    plot(nd+shift,asymrefmean(:,k),'k','linewidth',3), hold on
    plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'--k')
    plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'--k')    
    plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa,'r','linewidth',3)
    plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa+avg_aoa_sd,'--r')
    plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa-avg_aoa_sd,'--r')
    ylim(y)
    title('Average Angle of Attack Asymmetry'), box off
end



%%
% Big plot
figure
n=7;
% Body Roll
k=7;
pert_mean = nanmean(ga(:,:,k),2);
pert_sd = nanstd(ga(:,:,k),0,2);
refmean = roll_refmean;
refsd = roll_refsd;
subplot(n,1,1)
plot(nd+shift,refmean,'color',[.75 .75 .75], 'linewidth',3), hold on
plot(nd+shift,refmean+refsd,'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,refmean-refsd,'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean,'k','linewidth',3)
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean+pert_sd,'--k')
plot(0:.01:(.01*length(pert_mean)-.01),pert_mean-pert_sd,'--k')
title('Average Roll'), box off
ylim([-50 100]), xlim(xlm)

% Average Humeral Elevation Asymmetry
k=2;
avg_elev = nanmean(ga_asym(:,:,k),2);
avg_elev_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,2)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_elev)-.01),avg_elev,'k','linewidth',3)
plot(0:.01:(.01*length(avg_elev)-.01),avg_elev+avg_elev_sd,'--k')
plot(0:.01:(.01*length(avg_elev)-.01),avg_elev-avg_elev_sd,'--k')
title('Average Elevation Asymmetry'), box off
ylim([-10 50]), xlim(xlm)

% Average Retraction Asymmetry
k=3;
avg_prot = nanmean(ga_asym(:,:,k),2);
avg_prot_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,3)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_prot)-.01),avg_prot,'k','linewidth',3)
plot(0:.01:(.01*length(avg_prot)-.01),avg_prot+avg_prot_sd,'--k')
plot(0:.01:(.01*length(avg_prot)-.01),avg_prot-avg_prot_sd,'--k')
title('Average Retraction Asymmetry'), box off
ylim([-10 50]), xlim(xlm)

% Average Extension Asymmetry
k=1;
avg_ext = nanmean(ga_asym(:,:,k),2);
avg_ext_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,4)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_ext)-.01),avg_ext,'k','linewidth',3)
plot(0:.01:(.01*length(avg_ext)-.01),avg_ext+avg_ext_sd,'--k')
plot(0:.01:(.01*length(avg_ext)-.01),avg_ext-avg_ext_sd,'--k')
title('Average extension Asymmetry'), box off
ylim([-.10 .50]), xlim(xlm)

% Average Elbow Angle Asymmetry
k=4;
avg_elb = nanmean(ga_asym(:,:,k),2);
avg_elb_sd = nanstd(ga_asym(:,:,k),0,2);
y=[-10 70];
subplot(n,1,5)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_elb)-.01),avg_elb,'k','linewidth',3)
plot(0:.01:(.01*length(avg_elb)-.01),avg_elb+avg_elb_sd,'--k')
plot(0:.01:(.01*length(avg_elb)-.01),avg_elb-avg_elb_sd,'--k')
ylim(y)
title('Average Elbow Angle Asymmetry'), box off
ylim([-10 50]), xlim(xlm)


% Average Hand Spread Angle Asymmetry
k=5;
avg_hnd = nanmean(ga_asym(:,:,k),2);
avg_hnd_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,6)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd,'k','linewidth',3)
plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd+avg_hnd_sd,'--k')
plot(0:.01:(.01*length(avg_hnd)-.01),avg_hnd-avg_hnd_sd,'--k')
title('Average Hand Spread Angle Asymmetry'), box off
ylim([-10 80]), xlim(xlm)

% Average Angle of Attack Asymmetry
k=6;
avg_aoa = nanmean(ga_asym(:,:,k),2);
avg_aoa_sd = nanstd(ga_asym(:,:,k),0,2);
subplot(n,1,7)
% figure
plot(nd+shift,asymrefmean(:,k),'color',[.75 .75 .75],'linewidth',3), hold on
plot(nd+shift,asymrefmean(:,k)+asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])
plot(nd+shift,asymrefmean(:,k)-asymrefsd(:,k),'LineStyle','--','color',[.75 .75 .75])    
plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa,'k','linewidth',3)
plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa+avg_aoa_sd,'--k')
plot(0:.01:(.01*length(avg_aoa)-.01),avg_aoa-avg_aoa_sd,'--k')
title('Average Angle of Attack Asymmetry'), box off
ylim([-10 60]), xlim(xlm)


%% Plot Raw Daters
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Kinematics %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  For perturbed trials, average by perturbed wing and unperturbed wing
figure
n=7; % number of plots in subplot
shift=0.5; % shift control data along x-axis
xlm = [0 3];
% Body Roll
k=7;
pert = ga(:,:,k);
subplot(n,1,1)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Average Roll'), box off
xlim(xlm)
clear pert

% Humeral Elevation
x      = wng_pert_elev;
pert   = x(:,:,1);
unpert = x(:,:,2);
subplot(n,1,2)
plot(0:.01:(.01*length(pert)-.01),pert,'r','linewidth',3), hold on
plot(0:.01:(.01*length(unpert)-.01),unpert,'k','linewidth',3)
title('Humeral Elevation'), box off
xlim(xlm),ylim([-75 75])
clear pert unpert x

% Humeral Retraction
x      = wng_pert_prot;
pert   = x(:,:,1);
unpert = x(:,:,2);
subplot(n,1,3)
plot(0:.01:(.01*length(pert)-.01),pert,'r','linewidth',3), hold on
plot(0:.01:(.01*length(unpert)-.01),unpert,'k','linewidth',3)
title('Humeral Retraction'), box off
xlim(xlm),ylim([50 200])
clear pert unpert x

% Wing Extension
x      = wng_pert_ext;
pert   = x(:,:,1);
unpert = x(:,:,2);
subplot(n,1,4)
plot(0:.01:(.01*length(pert)-.01),pert,'r','linewidth',3), hold on
plot(0:.01:(.01*length(unpert)-.01),unpert,'k','linewidth',3)
title('Average Wing Extension'), box off
xlim(xlm),ylim([.3 1.2])
clear pert unpert x

% Elbow Extension
x      = wng_pert_elb;
pert   = x(:,:,1);
unpert = x(:,:,2);
subplot(n,1,5)
plot(0:.01:(.01*length(pert)-.01),pert,'r','linewidth',3), hold on
plot(0:.01:(.01*length(unpert)-.01),unpert,'k','linewidth',3)
title('Elbow Extension'), box off
xlim(xlm),ylim([0 150])
clear pert unpert x

% Handwing Abduction
x      = wng_pert_hnd;
pert   = x(:,:,1);
unpert = x(:,:,2);
subplot(n,1,6)
plot(0:.01:(.01*length(pert)-.01),pert,'r','linewidth',3), hold on
plot(0:.01:(.01*length(unpert)-.01),unpert,'k','linewidth',3)
title('Average Handwing Abduction'), box off
xlim(xlm),ylim([50 175])
clear pert unpert x

% Angle of Attack
x      = wng_pert_aoa;
pert   = x(:,:,1);
unpert = x(:,:,2);
subplot(n,1,7)
plot(0:.01:(.01*length(pert)-.01),pert,'r','linewidth',3), hold on
plot(0:.01:(.01*length(unpert)-.01),unpert,'k','linewidth',3)
title('Average Angle of Attack'), box off
xlim(xlm),ylim([-50 100])
clear pert unpert x

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Asymmetry %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Body Roll
figure
k=7;
pert = ga(:,:,k);
subplot(n,1,1)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Roll'), box off
ylim([-50 100]), xlim(xlm)

% Average Humeral Elevation Asymmetry
k=2;
pert = ga_asym(:,:,k);
subplot(n,1,2)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Elevation Asymmetry'), box off
ylim([-10 50]), xlim(xlm)

% Average Retraction Asymmetry
k=3;
pert = ga_asym(:,:,k);
subplot(n,1,3)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Retraction Asymmetry'), box off
ylim([-10 50]), xlim(xlm)

% Average Extension Asymmetry
k=1;
pert = ga_asym(:,:,k);
subplot(n,1,4)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Extension Asymmetry'), box off
ylim([-.10 .50]), xlim(xlm)

% Average Elbow Angle Asymmetry
k=4;
pert = ga_asym(:,:,k);
y=[-10 70];
subplot(n,1,5)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
ylim(y)
title('Elbow Angle Asymmetry'), box off
ylim([-10 75]), xlim(xlm)


% Average Hand Spread Angle Asymmetry
k=5;
pert = ga_asym(:,:,k);
subplot(n,1,6)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Hand Spread Angle Asymmetry'), box off
ylim([-10 80]), xlim(xlm)

% Average Angle of Attack Asymmetry
k=6;
pert = ga_asym(:,:,k);
subplot(n,1,7)
plot(0:.01:(.01*length(pert)-.01),pert,'linewidth',3)
title('Angle of Attack Asymmetry'), box off
ylim([-10 60]), xlim(xlm)

%% 
save('Asymmetry_Analysis')