function [ roll, pitch, yaw, rollV, pitchV, yawV ] = Calc_Body_Orientation_IndivGlobal( Data )
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here
%%

% Set-up Global Coordinate System
%z-positions
zHi = Data(1,67:69); %zHi(2,2:4);
zLo = Data(1,70:72); %

z_raw = zHi - zLo; %z-axis=zHi-zLo, origin at zLo
z_Norm = z_raw/norm(z_raw);

%y-positions
yRight = Data(1,76:78); % yRight(2,2:4);
yLeft = Data(1,73:75); % yLeft(2,2:4);

y_raw= yRight - yLeft; % y-axis = yRight-yLeft
% y_orig=y_raw;%-zLo; % Places origin at zLo
y_Norm = y_raw/norm(y_raw);

x_origNorm = cross(y_Norm,z_Norm);

x=x_origNorm;
z=z_Norm;
y=cross(z,x);


figure
d=Data;
    for i=1:22
        hold on
        plot3(d(:,i*3-2),d(:,i*3-1),d(:,i*3))
    end
    
mag=20; 
plot3([0 z(1)*mag],[0,z(2)*mag], [0 z(3)*mag],'b'), grid on, axis equal, hold on
plot3([0 y(1)*mag],[0,y(2)*mag], [0 y(3)*mag],'g')
plot3([0 x(1)*mag],[0,x(2)*mag], [0 x(3)*mag],'r')

        mag=1; 
plot3([d(1,70) d(1,67)*mag],[d(1,71),d(1,68)*mag], [d(1,72) d(1,69)*mag],'b'), grid on, hold on
plot3([d(1,73) d(1,76)*mag],[d(1,74),d(1,77)*mag], [d(1,75) d(1,78)*mag],'g')
grid on

grid on

% Only data for lmb, str, shdL, & shdR
data(:,:,1) = Data(:,61:63);    %lmb
data(:,:,2) = Data(:,1:3);    %shdL
data(:,:,3) = Data(:,4:6);    %shdR
% data(:,:,4) = Data(:,64:66);    %str

% Change of Origin
data = data-repmat(zLo(1,:),[size(data,1),1,size(data,3)]); %repmat(matrix,[rows, columns, depth]); (repeats a matrix and creates a new matrix)

% Coordinate Tansformation 
sz=length(data);
TransData=NaN(size(data));
for i=1:size(data,3);
    TransData(:,:,i)=coordinate_transform...
        (data(:,:,i),repmat(z,sz,1),repmat(y,sz,1),{'z','y'});
end
clear sz i

% Smooth Data
sData=NaN(size(TransData));
for i=1:size(data,3);
    for j=1:3 %Coordinates 1(x) and 2(y) and 3(z)
        ix=~isnan(TransData(:,j,i));
        [sData(ix,j,i)]=smooth_data(TransData(ix,j,i),2,15,800); %Function smooth_data can just operate with vectors (1-d-matrix)!
    end
end
clear i j ix data

%% Establish Local Coordinate-System
% data(:,:,1) = lmb
% data(:,:,2) = shdL
% data(:,:,3) = shdR
% data(:,:,4) = str

d(:,1:3) = sData(:,:,2); %shdL
d(:,4:6) = sData(:,:,3); %shdR
d(:,7:9) = sData(:,:,1); %lmb
% d(:,10:12) = sData(:,:,4); %str 


% Make shdmid the origin
shdmid = (d(:,1:3) + d(:,4:6)) / 2; % midpoint between shoulders in global coordinate system
shdorig = d - repmat(shdmid,1,size(d,2)/3);

%         % Plot new points to check origin
%         figure
% %         f=175;
%         for i=1:22
%             scatter3(shdorig(f,i*3-2),shdorig(f,i*3-1),shdorig(f,i*3),20,'filled')
%             hold on
%         end
%         hold on
%         plot3([shdorig(f,1) shdorig(f,4)],[shdorig(f,2) shdorig(f,5)],[shdorig(f,3) shdorig(f,6)],'k')
%         plot3([shdorig(f,4) shdorig(f,61)],[shdorig(f,5),shdorig(f,62)],[shdorig(f,6),shdorig(f,63)],'k')
%         plot3([shdorig(f,61),shdorig(f,1)],[shdorig(f,62) shdorig(f,2)],[shdorig(f,63) shdorig(f,3)],'k')
%         axis equal
%         xlabel('X axis')
%         ylabel('Y axis')
%         zlabel('Z axis')

% Define local axes using shdL, shdR, and lmb
for i=1:length(shdorig)
    mid(i,:)  = (shdorig(i,1:3) + shdorig(i,4:6)) / 2; % midpoint between shoulders in local coordinate system (Origin in local coordinate system)
    Y(i,:)    = shdorig(i,1:3) - shdorig(i,4:6); % vector from shdR to shdL (shdL-shdR)
    newX(i,:) = mid(i,:) - shdorig(i,7:9); % cranio-caudal axis (from lumbar to midpoint b/t shoulders; shd.mid- - lmb)
    newZ(i,:) = cross(newX(i,:),Y(i,:));% dorso-ventral axis orthogonal to CCaxis and shoulder vector, pointing dorsally
    newY(i,:) = cross(newZ(i,:),newX(i,:));
end

for i=1:length(newX)
    Xl(i,:) = newX(i,:)/norm(newX(i,:));
    Yl(i,:) = newY(i,:)/norm(newY(i,:));
    Zl(i,:) = newZ(i,:)/norm(newZ(i,:));
end

xUnitVector = Xl;
yUnitVector = Yl;
zUnitVector = Zl;

% Check that all UnitVectors have a magnitude of 1.
magnitude_xUnitVector=sqrt(xUnitVector(:,1).^2+xUnitVector(:,2).^2+xUnitVector(:,3).^2);
magnitude_yUnitVector=sqrt(yUnitVector(:,1).^2+yUnitVector(:,2).^2+yUnitVector(:,3).^2);
magnitude_zUnitVector=sqrt(zUnitVector(:,1).^2+zUnitVector(:,2).^2+zUnitVector(:,3).^2);


%%%%%%%%%%%%%%%%%
% 
% 
% % Calculate the center point between the shoulders
% for i=1:3
% sData(:,i,5) = (sData(:,i,2)+sData(:,i,3))/2;
% end
% clear i
% 
% % Define local X-Axis: Vector between the lumbar and the centerpoint (+X
% % towards head)
% xVector = sData(:,:,5)-sData(:,:,1);
% for i=1:length(xVector);
%     xUnitVector(i,:)=xVector(i,:)/norm(xVector(i,:));
% end
% clear i xVector
% 
% % Define local Y-Axis: Cross product of xVector and midpoint-->str vector
% % (+Y towards bat's left)
% xzVector = sData(:,:,4)-sData(:,:,5);
% for i=1:length(xzVector);
%     xzUnitVector(i,:)=xzVector(i,:)/norm(xzVector(i,:));
% end
% clear i xzVector
% 
% yUnitVector = cross(xUnitVector,xzUnitVector);
% 
% % Define local Z-Axis: Cross product of xVector and yVector (+Z is dorsal)
% zUnitVector=cross(xUnitVector,yUnitVector);
% 
% % Check that all UnitVectors have a magnitude of 1.
% % magnitude_xUnitVector=sqrt(xUnitVector(:,1).^2+xUnitVector(:,2).^2+xUnitVector(:,3).^2);
% % magnitude_yUnitVector=sqrt(yUnitVector(:,1).^2+yUnitVector(:,2).^2+yUnitVector(:,3).^2);
% % magnitude_zUnitVector=sqrt(zUnitVector(:,1).^2+zUnitVector(:,2).^2+zUnitVector(:,3).^2);


%% Calculate Rotations

%Define Vectors:
xUnitVector_AfterYaw = NaN(size(xUnitVector));
yUnitVector_AfterYaw = NaN(size(xUnitVector));
zUnitVector_AfterYaw = NaN(size(xUnitVector));
xUnitVector_AfterPitch = NaN(size(xUnitVector));
yUnitVector_AfterPitch = NaN(size(xUnitVector));
zUnitVector_AfterPitch = NaN(size(xUnitVector));
xUnitVector_AfterRoll = NaN(size(xUnitVector));
yUnitVector_AfterRoll = NaN(size(xUnitVector));
zUnitVector_AfterRoll = NaN(size(xUnitVector));

%Yaw Rotation of the Global-Coordinate-System around its Z-Axis

YawAngle=atan(xUnitVector(:,2)./xUnitVector(:,1)); %Calculate Rotation Angle for Yaw in Radians

%Transform bat's coordinate system so that it becomes referenced by x'-y'-z'-Coordinate-System.
for i=1:length(YawAngle)
    zRotMatrix=[cos(YawAngle(i)),sin(YawAngle(i)),0;-sin(YawAngle(i)),cos(YawAngle(i)),0;0,0,1]; %Around Z-Axis (Attention: Inverse Rotation-Matrix)
    xUnitVector_AfterYaw(i,:)=(zRotMatrix*xUnitVector(i,:)')';
    yUnitVector_AfterYaw(i,:)=(zRotMatrix*yUnitVector(i,:)')';
    zUnitVector_AfterYaw(i,:)=(zRotMatrix*zUnitVector(i,:)')';
end
clear i

%Pitch Rotation of the Global-Coordinate-System-Two around its Y-Axis

PitchAngle=atan(zUnitVector_AfterYaw(:,1)./zUnitVector_AfterYaw(:,3)); %Calculate Rotation Angle for Pitch in Radians

%Transform bat's coordinate system so that it becomes referenced by x''-y''-z''-Coordinate-System.
for i=1:length(YawAngle)
    yRotMatrix=[cos(PitchAngle(i)),0,-sin(PitchAngle(i));0,1,0;sin(PitchAngle(i)),0,cos(PitchAngle(i))]; %Around Y-Axis (Attention: Inverse Rotation-Matrix)
    xUnitVector_AfterPitch(i,:)=(yRotMatrix*xUnitVector_AfterYaw(i,:)')';
    yUnitVector_AfterPitch(i,:)=(yRotMatrix*yUnitVector_AfterYaw(i,:)')';
    zUnitVector_AfterPitch(i,:)=(yRotMatrix*zUnitVector_AfterYaw(i,:)')';
end
clear i

%Roll Rotation of the Global-Coordinate-System-Three around its X-Axis

RollAngle=atan(yUnitVector_AfterPitch(:,3)./yUnitVector_AfterPitch(:,2)); %Calculate Rotation Angle for Yaw in Radians

%Transform bat's coordinate system so that it becomes referenced by its own Coordinate-System. xUnitVector_AfterRoll should now be (1,0,0), yUnitVector_AfterRoll should now be (0,1,0) and zUnitVector_AfterRoll should now be (0,0,1).
for i=1:length(YawAngle)
    xRotMatrix=[1,0,0;0,cos(RollAngle(i)),sin(RollAngle(i));0,-sin(RollAngle(i)),cos(RollAngle(i))]; %Around X-Axis (Attention: Inverse Rotation-Matrix)
    xUnitVector_AfterRoll(i,:)=(xRotMatrix*xUnitVector_AfterPitch(i,:)')';
    yUnitVector_AfterRoll(i,:)=(xRotMatrix*yUnitVector_AfterPitch(i,:)')';
    zUnitVector_AfterRoll(i,:)=(xRotMatrix*zUnitVector_AfterPitch(i,:)')';
end
clear i

%Check that everything is working correctly

%Step 1: The y-component (2nd column) of xUnitVector_AfterYaw must be zero. --> TRUE! (Attention: The x-component (1st column) of yUnitVector_AfterYaw doesn't have to be zero, but is presumably close zo zero. - correct?)
%Step 2: The x-component (1st column) of zUnitVector_AfterPitch must be zero. --> TRUE! Also the xUnitVector_AfterPitch has to be equal to (1,0,0) --> TRUE! Also the x-component (1st column) of yUnitVector_AfterPitch has to be zero. --> TRUE!
%Step 3: The xUnitVector_AfterRoll should now be (1,0,0), the yUnitVector_AfterRoll should now be (0,1,0) and the zUnitVector_AfterRoll should now be (0,0,1). --> TRUE!

%Change Rotation Angles from Radians into Degree.
yaw   = radtodeg(YawAngle);
pitch = radtodeg(PitchAngle);
roll  = radtodeg(RollAngle);

%Organize y/p/r data and calculate angular velocities for body rotations -
%[smthd y/p/r, 1st der y/p/r] = smooth_data...
[yawsm, yawV]     = smooth_data(yaw,2,5,800);
[pitchsm, pitchV] = smooth_data(pitch,2,5,800);
[rollsm, rollV]   = smooth_data(roll,2,5,800);
% 
% %Organize variables into structure for current trial
% Data.(trl{1}).rot.yGlb = y; clear y
% Data.(trl{1}).rot.zGlb = z; clear z
% Data.(trl{1}).rot.xUV = xUnitVector; clear xUnitVector
% Data.(trl{1}).rot.yUV = yUnitVector; clear yUnitVector
% Data.(trl{1}).rot.zUV = zUnitVector; clear zUnitVector
% Data.(trl{1}).rot.Datarot = sData; clear sData

%Generate time array with first frame of gust at 0
% fr = 1/800; %framerate
% 
% if Data.(trl{1}).cdn == 'g'
%     g  = Data.(trl{1}).gst;
%     t  = horzcat(((-g(1)+1)/800):fr:0, (1/800):fr:((length(yaw(g(1):end))-1)/800))';
% else
%     t = 0:fr:((length(yaw)-1)/800);
% end
% t = t.*1000;
% Data.(trl{1}).rot.t = t;

%% Create mean reference trajectory
% Purple Yellow
%   Normalize to the wingbeat cycle
% Data = Trial_Data; 
% for trl = fieldnames(Data)';
% %     if Data.(trl{1}).cdn == 'c'
% %         Data.(trl{1}).rot.rmean = mean(Data.(trl{1}).rot.rollV,2);
% %     end
%     [Data.(trl{1}).rot.rollVn, Data.(trl{1}).rot.rVnDOM] = ...
%         norm_data(Data.(trl{1}).rot.rollV ,Data.(trl{1}).norm.strkdef, Data.(trl{1}).gst(1),Data.(trl{1}).cdn);
% end
% %% Plotting
% % Data = Trial_Data; for trl = fieldnames(Data)'; t=Data.(trl{1}).rot.t;
% %     % Orientation
% %     figure
% %     plot(t, Data.(trl{1}).rot.yaw,'g'), hold on
% %     plot(t, Data.(trl{1}).rot.pitch,'b')
% %     plot(t, Data.(trl{1}).rot.roll,'r')
% %     title(Data.(trl{1}).trl)
% %     xlabel('Time (s)')
% %     ylabel('Body Orientation (degrees)')
%  
%     % Rotational velocity
%     figure
% %     plot(t, Data.(trl{1}).rot.yawV,'g','linewidth',2), hold on
% %     plot(t, Data.(trl{1}).rot.pitchV,'b','linewidth',2)
%     plot(t, Data.(trl{1}).rot.rollV,'r','linewidth',2), hold on
% if isfield(Data.(trl{1}),'gst') == 1;   %gust duration
%     plot([0,0],[-5000,3500],'k--')
% end
% 
% 
%     title(Data.(trl{1}).trl)
%     xlabel('Time (ms)')
%     ylabel('Angular Velocity (degrees s^-^1)')
% %     legend('Yaw','Pitch','Roll')
%     ylim([-5000,3500])
% 
% clear YawAngle PitchAngle RollAngle yaw pitch roll z_temp y_temp xzUnitVector zUnitVector_AfterPitch yUnitVector_AfterPitch xUnitVector_AfterPitch ...
% zUnitVector_AfterRoll yUnitVector_AfterRoll xUnitVector_AfterRoll zUnitVector_AfterYaw yUnitVector_AfterYaw ...
% xUnitVector_AfterYaw TransData xRotMatrix yRotMatrix zRotMatrix trl t fr g
% 
% % end
% % 0:(1/800):length(Data.(trl{1}).rot.yaw)
end

