function [ Plots ] = plotkinematics_selected( wngext_L, wngext_R, elev_L, elev_R, gust, trl, roll, rollV, w_rmean, w_rstd, mse_ext )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

figure
        numplots = 4;
        xlm = [0 319];
        %Plot symmetry measure
        if size(mse_ext)>0
            numplots = numplots+1;
        end
            
        %Plot Body Roll Angle
        subplot(numplots,1,1)
        plot(roll,'r','linewidth',2), hold on, grid on
        ylm = [-100 100];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Roll','Pitch','Yaw')
        title('Body Orientation Angle')
        xlabel('Frame')
        
        %Plot Body Roll Angular Velocity
        subplot(numplots,1,2)
        plot(rollV,'r','linewidth',2), hold on, grid on
        ylm = [-3500 3000];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        plot([xlm(1),xlm(2)],[w_rmean,w_rmean],'color',[.85 .25 .25])
        plot([xlm(1),xlm(2)],[w_rstd,w_rstd],'--r')
        plot([xlm(1),xlm(2)],[-w_rstd,-w_rstd],'--r')
        xlim(xlm), ylim(ylm)
        ylabel('Angular Velocity (Degrees/s)')
        legend('Roll')
        title('Body Orientation Angular Velocity')
        xlabel('Frame')

        % Plot wing extension for L/R sides
        subplot(numplots,1,3)
        plot(wngext_L,'b','linewidth',2), hold on
        plot(wngext_R,'r','linewidth',2), grid on
        ylm = [5 20];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Extension (cm)')
        legend('Left','Right')
        title({trl;'';'Wing Extension (e)'})        
        
        % Plot Elevation/Depression angle for L/R sides
        subplot(numplots,1,4)
        plot(elev_L,'b','linewidth',2), hold on
        plot(elev_R,'r','linewidth',2), grid on
        ylm = [-100 100];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Left','Right')
        title('Humeral Elevation/Depression (\phi)')
        
        %Plot symmetry measure
        if size(mse_ext)>0
            subplot(numplots,1,5)
            plot(mse_ext,'k','linewidth',2'), hold on
        end
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm)
        ylabel('RMSE')
        title('Mean Standard Error in Wing Extension: Left vs. Right')
        
Plots = gcf;

end

