function [ GCSdata ] = Raw2Global( data, f1 )
%UNTITLED2 Summary of this function goes here
%   Detailed explanation goes here

% Data for testing
clear
close all
trl = 'PurpleYellow Control003';

% d_unfilt=csvread('/Users/davidboerma/Google Drive/Gust Response/Digitizing/PurpleYellow/PurpleYellow_fromPythonTracker/PY_c003_xyzpts.csv',1,0);
d_unfilt=csvread('/Users/davidboerma/Google Drive/Gust Response/Digitizing/PurpleYellow/PurpleYellow_fromPythonTracker/PY_c003_xyzpts_newShd.csv',1,0);

gust = []; %Frame range over which gust is acting on bat (No gust for this control trial)

% Filter Position Data
d = NaN(size(d_unfilt));

f1=21;
f2=175;

cutoff_freq = 100;
sample_freq = 800;
[p1,p2] = butter(2,cutoff_freq/(sample_freq/2),'low');
d(f1:f2,:) = filtfilt(p1,p2,d_unfilt(f1:f2,:));

d(1,67:78) = d_unfilt(1,67:78);

data = d;

%% Set-up Global Coordinate System Axes: defined by partition window
%z-positions
zHi = data(1,67:69); %zHi(2,2:4);
zLo = data(1,70:72); %

z_raw = zHi - zLo; %z-axis=zHi-zLo, origin at zLo
z_Norm = z_raw/norm(z_raw);

%y-positions
yRight = data(1,76:78); % yRight(2,2:4);
yLeft = data(1,73:75); % yLeft(2,2:4);

y_raw= yRight - yLeft; % y-axis = yRight-yLeft
% y_orig=y_raw;%-zLo; % Places origin at zLo
y_Norm = y_raw/norm(y_raw);

x_origNorm = cross(y_Norm,z_Norm);

Xg=x_origNorm;
Zg=z_Norm;
Yg=cross(Zg,Xg);


%% 3. Use dot products to Project point trajectories into global coordinate system using new global axes (for mathematical explanation, see Parent, Rick. Computer Animation: Algorithms and Techniques. p422, Figure B.7
Dg = NaN(size(data));

for i=1:size(data,1)
   for k=1:(size(data,2)/3)
       Dg(i,k*3-2:k*3) = [dot(data(i,k*3-2:k*3),Xg), dot(data(i,k*3-2:k*3),Yg), dot(data(i,k*3-2:k*3),Zg)];
   end
end

% Set origin to the position of lmb at f1 (first frame at which all points are digitized).

GCSdata = Dg-repmat(Dg(f1,61:63),size(Dg,1),size(Dg,2)/3);


%% Plot data to check 
% the X, Y, and Z axes of the plot in MATLAB should now reflect the
% X/Y/Z axes you defined (Note that simply plotting Xg, Yg, and Zg doesn't
% draw axes that are in these new X/Y/Z directions because those global
% axes are still defined in the old coordinate system)

figure, grid on, axis equal, hold on
d=GCSdata;
    for i=1:22
        hold on
        plot3(d(:,i*3-2),d(:,i*3-1),d(:,i*3))
    end
    

        mag=1; 
plot3([d(1,70) d(1,67)*mag],[d(1,71),d(1,68)*mag], [d(1,72) d(1,69)*mag],'b'), grid on, hold on
plot3([d(1,73) d(1,76)*mag],[d(1,74),d(1,77)*mag], [d(1,75) d(1,78)*mag],'g')
grid on

end

