function [ elev_L, elev_R, prot_L, prot_R ] = elev_str( LCSdata )
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here
%% Define bones as vector
% 3D Data Legend:
% Point #   Landmark   Columns
%    1        shdL       1:3
%    2        shdR       4:6
%    3        wstL       7:9
%    4        wstR      10:12
%    5        elbL      13:15
%    6        elbR      16:18
%    7         t3L      19:21
%    8         t3R      22:24
%    9         t4L      25:27
%    10        t4R      28:30
%    11        t5L      31:33
%    12        t5R      34:36
%    13       mcp3L     37:39
%    14       mcp3R     40:42
%    15       mcp4L     43:45
%    16       mcp4R     46:48
%    17       mcp5L     49:51
%    18       mcp5R     52:54
%    19       ankL      55:57
%    20       ankR      58:60
%    21       lmb       61:63
%    22       str       64:66

Dl = LCSdata;

% LEFT WING
humL = Dl(:,13:15) - Dl(:,64:66);   % L Humerus (elb-str)
humR = Dl(:,16:18) - Dl(:,64:66);   % R Humerus (elb-str)


%         figure
%         for f=200
%         scatter3(humL(f,1),humL(f,2),humL(f,3),'filled','b'), hold on
%         scatter3(humR(f,1),humR(f,2),humR(f,3),'filled','r'), axis equal, grid on
%         legend('Left','Right')
%         plot3([0 humL(f,1)],[0 humL(f,2)],[0 humL(f,3)],'b')
%         plot3([0 humR(f,1)],[0 humR(f,2)],[0 humR(f,3)],'r')
%         end
%         
%         figure
%         for f=1:length(wngL)
%         scatter3(wngL(f,1),wngL(f,2),wngL(f,3),'filled','b'), hold on
%         scatter3(wngR(f,1),wngR(f,2),wngR(f,3),'filled','r'), axis equal, grid on
%         legend('Left','Right')
%         plot3([0 wngL(f,1)],[0 wngL(f,2)],[0 wngL(f,3)],'b')
%         plot3([0 wngR(f,1)],[0 wngR(f,2)],[0 wngR(f,3)],'r')
%         end

%% 2. Calculate Humeral Elevation (Phi) and Protraction (Psi) using hum vectors
% This parameter is also considered "flapping" and "Sweep"
% Calculationsfor humeral motion performed using spherical coordinates of humerus in local coordinate system
% (See Riskin et al. 2008. Quantifying the complexity of bat wing kinematics. J. Theoretical Biology., Table 1)
% [protraction/retraction, elevation/depression, humerus length] = [hum_sph(:,1), hum_sph(:,3), hum_sph(:,3)]

% Humeral Elevation and Protraction
[humL_sph(:,1), humL_sph(:,2), humL_sph(:,3)] = cart2sph(humL(:,1), humL(:,2), humL(:,3));
humL_sph(:,1) = rad2deg(humL_sph(:,1));
humL_sph(:,2) = rad2deg(humL_sph(:,2));

[humR_sph(:,1), humR_sph(:,2), humR_sph(:,3)] = cart2sph(humR(:,1), humR(:,2), humR(:,3));
humR_sph(:,1) = rad2deg(humR_sph(:,1));
humR_sph(:,2) = rad2deg(humR_sph(:,2));

% Correct humeral angles for frames where radians excede 2pi
% For Protraction/Retraction Angle
if size(find(-humR_sph(:,1)<0)) > 0
    ix = find(-humR_sph(:,1)<0);
    for i=ix
        humR_sph(i,1) = humR_sph(i,1)-360;
    end
end

if size(find(humL_sph(:,1)<0)) > 0
    ix = find(humL_sph(:,1)<0);
    for i=ix
        humL_sph(i,1) = humL_sph(i,1)+360;
    end
end

elev_L = humL_sph(:,2);
elev_R = humR_sph(:,2);

prot_L = humL_sph(:,1);
prot_R = humR_sph(:,1);


end

