function [normalized_data,normalized_domain]=norm_data(data,SD,gust,condition) 
%data=data; SD=Frames of stroke definition; Gust=Frame of Beginning Gust;
%condition=c (control) or g (gust)


%gust is one value

%Hard code parameters
%Crop data to last upstroke
%Spline fit first wingbeat

%% hard code parameters
%% wingbeat after gust
%wingbeat fraction after gust to fit
if condition == 'c'
    wb_gust=.5; %.5 for half wingbeat, 1 for full wingbeat
elseif condition == 'g';
    wb_gust=.5;
else
    error('you fogot to define condition as ''c'' or ''g''')
end

spacing=.02;%wb percent spacing

%% crop
data=data(1:SD(end));

%% MODIFY GUST VALUE TO FIRST DIGITIZED FRAME
first_nonNaN=find((isnan(data(gust:SD(1)))==false)==1,1,'first');
gust=max(gust,first_nonNaN);


%% spline first wingbeat fraction after the gust
%define percentage of wingbeat that data is over
old_domain=linspace(0,wb_gust,length(data(gust:SD(1))));
new_domain=0:spacing:wb_gust;
%stretch/compress data to fit that domain
normalized_data(1:(wb_gust/spacing)+1)=...
    spline(old_domain,data(gust:SD(1)),new_domain); %make sure that the value for gust is less than SD(1)!!!
                                                    %Make gust=1 if you want to spline from the beginning of a
                                                    %trial, rather than from the first frame of gust contact

%% Spline rest of full wingbeats
% rinse and repeat
for w=1:(length(SD)-1)
    old_domain=linspace(spacing,1,length(data(SD(w)+1:SD(w+1))));
    new_domain=spacing:spacing:1;
    x=length(normalized_data);
    normalized_data(x+1:x+length(new_domain))=...
        spline(old_domain,data(SD(w)+1:SD(w+1)),new_domain);
end

% normalized_domain=[0:spacing:1, 1+spacing:spacing:length(SD)];

normalized_domain=[(1-wb_gust):spacing:1, 1+spacing:spacing:length(SD)];

normalized_data   = normalized_data';
normalized_domain = (normalized_domain/2)';
end