function [ Plots ] = plotKinematics( wngext_L, wngext_R, elev_L, elev_R, prot_L, prot_R, elbL, elbR, dang3_radL, dang3_radR, gust, trl, roll, pitch, yaw, rollV, yawV, pitchV )
%UNTITLED4 Summary of this function goes here
%   Detailed explanation goes here
%% Part 10: Plot All Kinematics

        figure
        % Plot wing extension for L/R sides
        numplots = 7;
        subplot(numplots,1,1)
        plot(wngext_L,'b','linewidth',2), hold on
        plot(wngext_R,'r','linewidth',2), grid on
        xlm = [0 250]; ylm = [5 20];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Extension (cm)')
        legend('Left','Right')
        title({trl;'';'Wing Extension (e)'})
        
        % Plot Elevation/Depression angle for L/R sides
        subplot(numplots,1,2)
        plot(elev_L,'b','linewidth',2), hold on
        plot(elev_R,'r','linewidth',2), grid on
        xlm = [0 250]; ylm = [-100 100];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Left','Right')
        title('Humeral Elevation/Depression (\phi)')
        
        % Plot sweep angle for L/R sides
        subplot(numplots,1,3)
        plot(prot_L,'b','linewidth',2), hold on
        plot(-prot_R,'r','linewidth',2), grid on 
        xlm = [0 250]; ylm = [0 225];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Left','Right')
        title('Humeral Protraction/Retraction (\psi)')
        
        %Plot elbow angle for L/R sides
        subplot(numplots,1,4)
        plot(elbL,'b','linewidth',2), hold on
        plot(elbR,'r','linewidth',2), grid on
        xlm = [0 250]; ylm = [0 130];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Left','Right')
        title('Elbow Flexion/Extension')
        xlabel('Frame')
        
        %Plot Handwing folding for L/R sides
        subplot(numplots,1,5)
        plot(dang3_radL,'b','linewidth',2), hold on
        plot(dang3_radR,'r','linewidth',2), grid on
        xlm = [0 250]; ylm = [0 200];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Left','Right')
        title('Handwing Spreading/Folding')
        xlabel('Frame')
        
        %Plot Body Orientation Angle
        subplot(numplots,1,6)
        plot(roll,'r','linewidth',2), hold on
        plot(pitch, 'g', 'linewidth',2)
        plot(yaw, 'b', 'linewidth',2)
        xlm = [0 250]; ylm = [-100 100];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angle (Degrees)')
        legend('Roll','Pitch','Yaw')
        title('Body Orientation Angle')
        xlabel('Frame')
        
        %Plot Body Orientation Angular Velocity
        subplot(numplots,1,7)
        plot(rollV,'r','linewidth',2), hold on
        plot(pitchV, 'g', 'linewidth',2)
        plot(yawV, 'b', 'linewidth',2)
        xlm = [0 250]; ylm = [-3500 3000];
        if size(gust)>0
        plot([gust(1) gust(1)],[ylm(1) ylm(2)],'--k','linewidth',2)
        plot([gust(2) gust(2)],[ylm(1) ylm(2)],'--k','linewidth',2)
        end
        xlim(xlm), ylim(ylm)
        ylabel('Angular Velocity (Degrees/s)')
        legend('Roll','Pitch','Yaw')
        title('Body Orientation Angular Velocity')
        xlabel('Frame')

Plots = gcf;

end

